<?php
class sqlExport{
	private $table;
	private $con;
	private $Field;
	private $fields;
	
	public function __construct($table, $con){
		$this->table = $table;
		$this->con = $con;
	}
	public function export(){
		try {
			$header = $this->create_header();
			$data = $this->get_data();
			$outFile = $this->table . ".sql";
			$file = fopen($outFile,"w+");
			$exported = $header . $data;
			fwrite($file,$exported);
			fclose($file);
			return($outFile);
		}catch (Exception $e){
			throw $e;
		}
	}	
	function create_header(){
		try {
			$sql = "SHOW COLUMNS FROM $this->table ";
			$res = $this->con->query($sql);
			unset($h,$key);
			$h = "CREATE TABLE `" . $this->table . "` (";
			unset($Fields);
			while($row = $this->con->fetch($res)){
				if($row['Field'] != $this->table ."_id"){
					$this->fields .= "`" . $row["Field"] ."`,";
					$this->Field[count($this->Field)] = $row["Field"];
					$name = $row['Field'];
					$flags = $row['Extra'];
					$type = $row['Type'];
					$extra = $row['Extra'];
					if($row['Null'] != 'YES'){
						$null = " NOT NULL ";
					}else{
						$null = '';
					}				
					
					$h .= "`$name` $type $null $extra,";
						//$key = "PRIMARY KEY  (`$name`)";
				}			
			}
			$this->fields = substr($this->fields,0,strlen($this->fields)-1);
			$this->fields.= " ";
			//if($key == ''){
				$h = substr($h,0,strlen($h)-1);			
			//}		
			$h .= ");\n\n";
			return($h);
		}catch (Exception $e){
			throw $e;
		}
	}
	function get_data(){
		try {
			$d = null;
			$sql = "SELECT $this->fields FROM `$this->table` WHERE 1";
			$res = $this->con->query($sql);
			while($row = $this->con->fetch($res))
			{
				$d .= "INSERT INTO `" . $this->table . "` VALUES (";
				for($F = 0; $F < count($this->Field); $F++){
					if($row[$this->Field[$F]] == ''){
						$d .= "NULL,";
					}else {
						$d .= "'".$row[$this->Field[$F]]."',";
					}
				}
				$d = substr($d, 0, strlen($d) - 1);
				$d .= ");\n";
			}
			return($d);
		}catch (Exception $e){
			throw $e;
		}
	}	
}
?>