<?php
/**
 * 
 * @package algorithmform
 */
class dupgrid{
	
	private $addReplace;
	private $table_name;
	private $editable_attrib;
	private $queryparam;
	private $div;
	private $Form;
	private $id_alg;
	private $con;
	private $final_table;
	private $formGen;
	
	public function __construct($table_name, $editable_attrib, $queryparam, $div,$Form, $id_alg, $final_table){		
		$this->table_name = $table_name;
		$queryparam = str_replace("'","|||",$queryparam);
		$this->editable_attrib = explode(",",$editable_attrib);
		$this->queryparam = $queryparam;
		$this->div = $div;
		$this->Form = $Form;
		$this->id_alg = $id_alg;
		$this->con = $con;
		$this->final_table = $final_table;
	}
	public function define_grid($con){
		try {
			$this->con = $con;
			//$this->con->abrir();		
			$query = "SHOW COLUMNS FROM $this->table_name ";
			$res = $this->con->query($query);
			$FieldId = 0;
			$js2 = "var dateItems = new Array(); var dateTimeItems = new Array(); var timeItems = new Array();";
			$withTime = '';
			unset($jsonreader,$columnmodel);
			while($row= $this->con->fetch($res)){
				if($FieldId == 0){
					$id = $row["Field"];
					$FieldId = 1;
				}else{
					$name = str_replace(" ","__", $row["Field"]);
	//				$name = "___" . str_replace(" ","____", $row["Field"]) . "___";
					if($row['Type'] == 'double'){
						$types = 'float';
						$kindofcol = 'NumberField';
						$format = "";
					}elseif($row['Type'] == 'varchar(255)'){
						$types = 'string';
						$kindofcol = 'TextField';
						$format = "";
					}elseif($row['Type'] == 'date'){
						$types = 'date';
						$kindofcol = 'DateField';
						$format = " ,dateFormat:'Y-m-d'";
						$withTime = "no";					
						//$types = 'string';
					//	$kindofcol = 'TextField';
					}elseif ($row['Type'] == 'datetime'){
						$types = 'date';
						$kindofcol = 'DateField';
						$format = " ,dateFormat:'Y-m-d H:i:s'";
						$withTime = "yes";
					}elseif ($row['Type'] == 'time'){
						$types = 'date';
						$kindofcol = 'DateField';
						$format = " ,dateFormat:'H:i:s'";
						$withTime = "onlytime";
					}
					$jsonreader .= "{name: '". $name . "', mapping: '". $row["Field"]."', type: '" .$types . "' $format},";
					$columnmodel .= "{						
							id: '". "i" . $name. "i" ."',
							header: '". $row["Field"] . " (" .$row["Type"] . ")" ."',
							dataIndex: '". $name ."',						
							width: 120,";
					if($kindofcol == 'DateField'){
						if($withTime == "no"){
							$columnmodel.= "renderer: formatDate,";
							$js2 .= "dateItems.push('".$row["Field"]."');";
						}elseif($withTime == "yes"){
							$columnmodel.= "renderer: formatDateTime,";
							$js2 .= "dateTimeItems.push('".$row["Field"]."');";
						}else{
							$columnmodel.= "renderer: formatTime, ";
							$js2 .= "timeItems.push('".$row["Field"]."');";
						}							
					}
					$limitedext = array(".csv",".arff",".xls",".sql");
					if($this->editable_attrib[0] == '*' || in_array($row["Field"],$this->editable_attrib) ){
						$columnmodel .="
							editor: new Ed(new fm.". $kindofcol . "({";
							if($kindofcol == 'DateField'){
								if($withTime == "no"){
									$columnmodel.= "dateFormat: 'Y-m-d', format: 'Y-m-d',";
								}elseif($withTime == "yes"){
									$columnmodel.= "dateFormat: 'Y-m-d H:i:s', format: 'Y-m-d H:i:s',";
								}else{
									$columnmodel.= "dateFormat: 'H:i:s', format: 'H:i:s',";
								}
							}
							if($kindofcol == 'NumberField'){
								$columnmodel.= "decimalPrecision: 20, ";
							}
							$columnmodel.="
							allowBlank: true	}))
						},";					
					}else{
						$columnmodel .= "},";
					}				
				}
			}
			$jsonreader = substr($jsonreader,0,strlen($jsonreader)-1);
			$columnmodel = substr($columnmodel,0,strlen($columnmodel)-1);
			//-------------
			//-------------
			//-------------
		//	$xres->script($js2);
			//-------------
			//-------------
			//-------------
			$js = "
				function formatDate(value){
					return value ? value.dateFormat('Y-m-d') : '';
	   			}
				function formatDateTime(value){
					return value ? value.dateFormat('Y-m-d H:i:s') : '';
	   			}
				function formatTime(value){
					return value ? value.dateFormat('H:i:s') : '';
	   			}	
				var ps1 = 50;
				ds1 = new Ext.data.Store({			
					proxy: new Ext.data.ScriptTagProxy({
						url: '../../class/msg/datafile.php'
					}),
					reader: new Ext.data.JsonReader({			
						root: 'results',
						totalProperty: 'total',
						id: '$id'
					}, 
					[ ". $jsonreader ." ])
				});
				ds1.baseParams = {'table_name': '$this->table_name', 'query':'$this->queryparam'};
				fm = Ext.form, Ed = Ext.grid.GridEditor;
				cm1 = new Ext.grid.ColumnModel([$columnmodel]);
				grid_alg = new Ext.grid.EditorGrid('$this->div', {
					ds: ds1,
					cm: cm1,
					selModel: new Ext.grid.RowSelectionModel(),	
					loadMask: {msg: 'Retreiving Data, Please Wait...'},			
					listeners:{
						'afteredit': function(oe){
							for(var g = 0; g<dateItems.length; g++){							
								if(oe.field == dateItems[g]){
									oe.value = formatDate(oe.value);
								}
							}
							for(var g = 0; g<dateTimeItems.length; g++){							
								if(oe.field == dateTimeItems[g]){
									oe.value = formatDateTime(oe.value);
								}
							}
							for(var g = 0; g<timeItems.length; g++){							
								if(oe.field == timeItems[g]){
									oe.value = formatTime(oe.value);
								}
							}
							xajax_Grid_Update(ds1.data.items[oe.row].id, oe.field, oe.value , '$this->table_name');
						}
					}
				});
				grid_alg.render();
				//----------------- context menu inside de grid
				var ctxMenu = new Ext.menu.Menu({
					items: [
						{							
							id:'remove',
							//handler:removeNode,
							cls:'x-btn-text-icon remove',
							text: 'Remove',
							icon : '../../icons/cross.gif'
						}
					]
				});	
				ctxMenu.items.get('remove').on('click', function(e){
					var selectionModel = grid_alg.getSelectionModel();
					var rows = selectionModel.getSelections();
					var nb = rows.length;
					for(var i=0;i<nb;i++){
						xajax_Grid_Delete(rows[i].id, '$this->table_name');	
					}
					ctxMenu.hide();
					ds1.reload();
				});
				grid_alg.on('cellcontextmenu',function(grid, rowIndex, cellIndex, event){
					ctxMenu.showAt(event.getXY());
					event.preventDefault(); // To not display the browser context menu
				});
				//-----------------------			
				//-----------------------
				gridFoot = grid_alg.getView().getFooterPanel(true);	
				paging = new Ext.PagingToolbar(gridFoot, ds1, {
					pageSize: ps1,
					displayInfo: true,
					displayMsg: 'Displaying results {0} - {1} of {2}',
					emptyMsg: 'No results to display'
				});	
				//-------- combo box to set a limit of rows show for the grid			
				PerPageData = [
					['10', 	'10'],
					['25', 	'25'],
					['50', 	'50'],
					['100', '100']
				];
				var ppstore = new Ext.data.SimpleStore({
					fields: ['num', 'txt'],
					data : PerPageData
				});		
				var perPage = new Ext.form.ComboBox({
					store: ppstore,
					displayField:'txt',
					typeAhead: true,
					mode: 'local',
					triggerAction: 'all',
					selectOnFocus:true,
					resizable:false,
					listWidth: 60,
					width: 60,
					value: '50'
				});
		
				function setPerPage()
				{
					paging.pageSize = parseInt(perPage.getValue());	
					paging.cursor = 0;
					ds1.load({params:{start: paging.cursor, limit: paging.pageSize}});
				}
				perPage.on('select', setPerPage);
			
				paging.addSeparator();
				paging.addText('Per Page');		
				paging.addField(perPage);			
				//-----------	
				var gridHead = grid_alg.getView().getHeaderPanel();
				gridHead.show();
				var tb = new Ext.Toolbar(gridHead);
				var delete_all = tb.add({
					text: 'Delete All',
					id: 'delete_all',
					tooltip: 'Delete all rows.',
					icon: '../../icons/cross.gif',
					cls: 'x-btn-text-icon btn-search-icon',
					handler: delete_all
				});
				function delete_all(btn){
					ds1.removeAll();
					/*grid_alg.destroy(true);
					dialog_cct.hide();
					dialog_cct.destroy();*/
					xajax_Grid_DeleteGroup('$this->id_alg', '$this->table_name','');
					}";
				$js.="
				//------- to add a export menu.
				Ext.get(Ext.get(tb.addSpacer().getEl()).dom.parentNode).setStyle('width', '100%');
				tb.add({
					cls: 'x-btn-text-icon bmenu', // icon and text class
					icon: '../../icons/disk.gif',
					text:'Export',
					menu:{items: [
						{	text: '<b>XLS</b>',
						 	icon: '../../icons/excel.png',
						 	handler: function(){
						 		xajax_Export('$this->table_name',1);
						 	}
						},
						{	text: '<b>CSV</b>',
							icon: '../../icons/csv.gif',
							handler: function(){
						 		xajax_Export('$this->table_name',2);
						 	}
						},
						{	text: '<b>SQL</b>',
							icon: '../../icons/sql.gif',
							handler: function(){
								xajax_Export('$this->table_name',3);
							}
						},
						{	text: '<b>ARFF</b>',
							icon: '../../icons/arff.gif',
							handler: function(){
								xajax_Export('$this->table_name',4);
							}
						 }
					]}
				});
				//don't touch
				ds1.load({params:{start:0, limit:ps1}});
				//---------------------- form
				$this->formGen";
				//
				$javascript = $js2 . $js;
				//$javascript = $js;
				//		
			return $javascript;
		}catch (Exception $e){
			throw($e);
		}
	}
	public function getForm(){
		return $this->formGen;
	}
	public function setForm(){
		try{
			$this->formGen = "
				form_alg = new Ext.form.Form({
					labelWidth: 100
				});
				form_alg.addButton({
						text: 'Save Table',						
						handler: function(){														
							xajax_MatchTableCreate('$this->table_name','$this->final_table');
						}
					});
				form_alg.addButton({
					text: 'Close',
					handler: function(){
						grid_alg.destroy(true);
						dialog_cct.hide();
						dialog_cct.destroy();
						if(grid_is_load == 1){
							grid.getDataSource().reload();
						}
					}
				});
				form_alg.render('formulario');
			";
		}catch (Exception $e){
			throw ($e);
		}
	}	
}
?>