CREATE TABLE `archivos` (
  `id_arch` int(11) NOT NULL auto_increment,
  `id_usu` int(11) default NULL,
  `arch_usu` varchar(255) default NULL,
  `fecha` datetime default NULL,
  `num_tabxfile` int(11) default NULL,
  PRIMARY KEY  (`id_arch`),
  KEY `id_usu` (`id_usu`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `tabxfile` (
  `id_tabla` int(11) NOT NULL auto_increment,
  `id_arch` int(11) default NULL,
  `nom_tabla` varchar(255) default NULL,
  `descripcion` blob default NULL,
  PRIMARY KEY  (`id_tabla`),
  KEY `id_arch` (`id_arch`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `usuario` (
  `id_usu` int(11) NOT NULL auto_increment,
  `firstname` varchar(30) NOT NULL,
  `lastname` varchar(30) NOT NULL,
  `login` varchar(20) NOT NULL,
  `pass` varchar(255) default NULL,
  `ruta` varchar(255) NOT NULL,
  `online` char(1) NOT NULL,
  PRIMARY KEY  (`id_usu`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8  ROW_FORMAT=COMPRESSED;

ALTER TABLE `archivos`
  ADD FOREIGN KEY (`id_usu`) REFERENCES `usuario` (`id_usu`) ON UPDATE CASCADE;

ALTER TABLE `tabxfile`
  ADD FOREIGN KEY (`id_arch`) REFERENCES `archivos` (`id_arch`) ON UPDATE CASCADE;