<?php
class NullClean{

	private $table_name;
	private $col_name;
	private $func;
	private $con;
	
	public function __construct(){
		
	}
		
	public function NullClean($table_name, $col_name, $func, $con){
		
		try {
		
		$this->con = $con;
		$this->table_name = $table_name;
		$this->col_name = $col_name;
		$this->func = $func;
		$ret[0] = "";
		$ret[1] = "";
		
		switch ($this->func){
			
		    case 'average':
				$sql = "SELECT AVG($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);
				unset($val);
				$val = $this->con->fetch($res2);
				$sql = "UPDATE $this->table_name SET $this->col_name = ".round($val[0],2)." WHERE $this->col_name IS NULL";
				$this->con->query($sql);
				$ret[0] = "The null values was filled with the value ".round($val[0],2)." (average).";
			break;
		    case 'max':
				$sql = "SELECT MAX($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);
				unset($val);
				$val = $this->con->fetch($res2);
				$sql = "UPDATE $this->table_name SET $this->col_name = ".round($val[0],2)." WHERE $this->col_name IS NULL";
				$this->con->query($sql);
				$ret[0] = "The null values was filled with the value ".round($val[0],2)." (max).";
			break;
		    case 'min':
				$sql = "SELECT MIN($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);
				unset($val);
				$val = $this->con->fetch($res2);
				$sql = "UPDATE $this->table_name SET $this->col_name = ".round($val[0],2)." WHERE $this->col_name IS NULL";
				$this->con->query($sql);
				$ret[0] = "The null values was filled with the value ".round($val[0],2)." (min).";
			break;
		    case 'supr':
				$sql = "DELETE FROM $this->table_name WHERE $this->col_name IS NULL";
				$this->con->query($sql);
				$ret[0] = "The rows that contains null values on the field $this->col_name was deleted";
			break;
			case 'variance':
				$sql = "SELECT VAR_POP($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);
				unset($val);
				$val = $this->con->fetch($res2);
				$sql = "UPDATE $this->table_name SET $this->col_name = ".round($val[0],2)." WHERE $this->col_name IS NULL";
				$this->con->query($sql);
				$ret[0] = "The null values was filled with the value ".round($val[0],2)." (variance).";
			break;
			case 'sum':
				$sql = "SELECT SUM($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);
				unset($val);
				$val = $this->con->fetch($res2);
				$sql = "UPDATE $this->table_name SET $this->col_name = ".round($val[0],2)." WHERE $this->col_name IS NULL";
				$this->con->query($sql);
				$ret[0] = "The null values was filled with the value ".round($val[0],2)." (sum).";
			break;
			case 'random_mid':
				unset($mid, $dev);
				$sql = "SELECT AVG($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);				
				$val = $this->con->fetch($res2);
				$mid = $val[0];
				
				$sql = "SELECT STDDEV_POP($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);				
				$val = $this->con->fetch($res2);
				$dev = $val[0];
				$min = $mid - $dev;
				$sql = "UPDATE $this->table_name SET $this->col_name = ROUND($min + (RAND() * (2*$dev)),2) WHERE $this->col_name IS NULL;";
				$this->con->query($sql);
				$down = round($mid-$dev,2);
				$up = round($mid+$dev,2);
				$ret[0] = "The null values was filled with values between " . $down . "-" . $up .".";				
			break;
			case 'random_full':				
				$sql = "SELECT MAX($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);
				$val = $this->con->fetch($res2);
				$max = $val[0];
				$sql = "SELECT MIN($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);
				$val = $this->con->fetch($res2);
				$min = $val[0];
				$tam = $max - $min;
				$sql = "UPDATE $this->table_name SET $this->col_name = ROUND($min + (RAND() * ($tam)),2) WHERE $this->col_name IS NULL;";
				$this->con->query($sql);
				$ret[0] = "The null values was filled with values between ".$min." - ".$max;
			break;
			case 'mode':
				$sql = "SELECT $this->col_name, COUNT($this->col_name) AS cant FROM $this->table_name WHERE $this->col_name IS NOT NULL GROUP BY $this->col_name ORDER BY cant DESC";
				$res2 = $this->con->query($sql);			
				$x = 0;
				while ($fila = $this->con->fetch($res2)){
					$mat['col'][$x] = $fila[0];
					$mat['can'][$x] = $fila[1];
					$x++;					
				}
				$max = max($mat['can']);
				unset($val);
				$y = 0;
				for ($x= 0; $x < count($mat['can']); $x++){
					if($mat['can'][$x] == $max){
						$val[$y] = $mat['col'][$x];
						$y++;
					}
				}
				$sql = "UPDATE $this->table_name SET $this->col_name = ". round($val[mt_rand(0,count($val)-1)],2)." WHERE $this->col_name IS NULL";
				$this->con->query($sql);
				$ret[0] = "The Null values was filled with the value ".round($val[mt_rand(0,count($val)-1)],2)." (mode).";
			break;
			case 'zero':
				$sql = "UPDATE $this->table_name SET $this->col_name = 0 WHERE $this->col_name IS NULL";
				$this->con->query($sql);
				$ret[0] = "The null values was filled with 0.";
			break;
			case 'class_rule':			
				$sql = "SELECT MAX($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);
				$val = $this->con->fetch($res2);
				$max = $val[0];
				$sql = "SELECT MIN($this->col_name) FROM $this->table_name WHERE $this->col_name IS NOT NULL;";
				$res2 = $this->con->query($sql);
				$val = $this->con->fetch($res2);
				$min = $val[0];
				$sql = "UPDATE $this->table_name SET $this->col_name = " . round(($min + $max)/2,2) . " WHERE $this->col_name IS NULL";
				$this->con->query($sql);
				$ret[0] = "The null values was filled with the value ".round(($min + $max)/2,2)." (Class Rule).";
			break;		
			default:				
			break;
		}
		$ret[1] = "ok";
		return $ret;
		}catch (Exception $e){
			throw $e;
		}
	}
}
?>