<?php
class ChangeColumnType{
	
	public function __construct(){
		
	}
	
	public function ChangeColumnToDouble($table_base, $table_dest, $column, $con){
		$sql = "DROP TABLE IF EXISTS $table_dest";
		$con->query($sql);
		$sql = "CREATE TABLE $table_dest AS SELECT * FROM $table_base WHERE NOT (`$column` REGEXP '^-?([0-9]+(\.)?[0-9]*$|(\.)[0-9]+$)') AND `$column` IS NOT NULL AND `$column` != '';";	
		$con->query($sql);
		$oldId = $table_base . "_id";
		$newId = $table_dest . "_id";
		$sql = "ALTER TABLE $table_dest CHANGE COLUMN `$oldId` `$newId` double NOT NULL default '0';";
		$con->query($sql);
		$sql = "SELECT COUNT(*) FROM $table_dest;";
		$res = $con->query($sql);
		$val = $con->fetch($res);
		$mat['count'] = $val[0];
		$mat['answer'] = "ok";
		return $mat;
	}
	
	
	public function ChangeColumnToInt($table_base, $table_dest, $column, $con){
		
		$sql = "DROP TABLE IF EXISTS $table_dest;";
		$con->query($sql);
		$sql = "CREATE TABLE $table_dest AS SELECT * FROM $table_base WHERE NOT (`$column` REGEXP '^-?([0-9])+$') AND `$column` IS NOT NULL AND `$column` != '';";
		$con->query($sql);
		$oldId = $table_base . "_id";
		$newId = $table_dest . "_id";
		$sql = "ALTER TABLE $table_dest CHANGE COLUMN `$oldId` `$newId` int(11) NOT NULL default '0';";
		$con->query($sql);
		$sql = "SELECT COUNT(*) FROM $table_dest;";
		$res = $con->query($sql);
		$val = $con->fetch($res);
		$mat['count'] = $val[0];
		$mat['answer'] = "ok";
		return $mat;
	}
	
	public function ChangeColumnToDate($table_base, $table_dest, $column, $dformat, $delimiter, $con){
		unset($sql,$oldId,$newId);
		$sql = "DROP TABLE IF EXISTS $table_dest;";
		$con->query($sql);
		$sql = "CREATE TABLE $table_dest AS SELECT * FROM $table_base;";
		$con->query($sql);
		$sql = "TRUNCATE $table_dest;";
		$con->query($sql);
		$oldId = $table_base . "_id";
		$newId = $table_dest . "_id";
		$sql = "ALTER TABLE $table_dest CHANGE COLUMN `$oldId` `$newId` double NOT NULL default '0';";
		$con->query($sql);
		switch ($dformat){
			case "YMD": $dformat = "012"; break;
			case "YDM": $dformat = "021"; break;
			case "DMY": $dformat = "210"; break;
			case "DYM": $dformat = "120"; break;
			case "MYD": $dformat = "102"; break;
			case "MDY": $dformat = "201"; break;
		}
		$pos = str_split($dformat);		
		$meses = array(99,31,28,31,30,31,30,31,31,30,31,30,31);
		$messp = array("x","enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre");
		$mesen = array("x","january","february","march","april","may","june","july","august","september","october","november","december");
		$sql = "SELECT * FROM $table_base WHERE `$column` IS NOT NULL AND `$column` != '' AND `$column` != '0000-00-00';";

		$res = $con->query($sql);
		$cant = 0;		
		while($fila = $con->fetch($res)){
			unset($fecha);
			$fecha = explode($delimiter,$fila[$column]); ////////FALTA	
			$ano = trim($fecha[$pos[0]]);
			$mes = trim($fecha[$pos[1]]);
			$dia = trim($fecha[$pos[2]]);
			
			if(ereg("^[0-9][0-9]$", $ano)){
				$ano = "20".$ano;				
			}
			
			$mes = strtolower($mes);
			for ($x=1;$x<=count($meses);$x++){
				if ($mes == $messp[$x] || $mes == substr($messp[$x],0,3) || $mes == $mesen[$x] || $mes == substr($mesen[$x],0,3)){
					if($x<10){
						$mes="0".$x;
					}else {
						$mes=$x;
					}
				}
			}
			
			$cadena = $ano . "-" . $mes . "-" . $dia;			
			$fallo = false;											
			if(!ereg("^([0-9]{4})-((0?[0-9])|(1[0-2]))-((0?[0-9])|((1|2)[0-9])|(3[0-1]))$", $cadena)){
				$fallo = true;
			}else{
				if(($ano>=0 && $ano<=9999) && ($mes>0 && $mes<=12) && (($dia>0 && $dia<=$meses[intval($mes)]) || ($mes ==2 && $dia==29 && ( ($ano % 400) == 0 || (($ano % 4) == 0 && ($ano % 100) != 0))))){
				}else {
					$fallo = true;
				}
			}

			if ($fallo == true){
				unset($cons);
				for($x=0;$x<=(count($fila)/2)-1;$x++){
					$fila[$x] = str_replace("'","\'",$fila[$x]);
					$fila[$x] = str_replace('"','\"',$fila[$x]);
					$cons .= " '$fila[$x]',";
				}
				$cons = trim(substr($cons,0,strlen($cons)-1));
				$cant++;
				if($cant == 2001){
					$query = substr($query,0,strlen($query)-1);					
					$con->query($query);
					$cant = 1;
				}
				if ($cant == 1){
					$query = "INSERT INTO $table_dest VALUES ($cons),";					
				}else{
					$query .= "($cons),";
				}
			}
		}		
		if($cant < 2001 && $cant > 0){
			$query = substr($query,0,strlen($query)-1);			
			$con->query($query);	
		}
		unset($res,$sql,$val,$mat);
		$sql = "SELECT COUNT(*) FROM $table_dest;";
		$res = $con->query($sql);
		$val = $con->fetch($res);
		$mat['count'] = $val[0];
		$mat['answer'] = "ok";		
		return $mat;
	}
	
	public function TransformToDate($table_name, $column, $dformat, $delimiter, $con){
		
		unset($sql);
		
		$sql = "UPDATE $table_name SET $column = REPLACE($column,'$delimiter','-')";
		$con->query($sql);
		
		$sql="UPDATE $table_name SET $column = TRIM(LOWER($column));";
		$con->query($sql);
		
		$sql="UPDATE $table_name SET 
			$column = REPLACE($column,'january','01'),
			$column = REPLACE($column,'enero','01'),
			$column = REPLACE($column,'ene','01'),
			$column = REPLACE($column,'jan','01'),
			$column = REPLACE($column,'febrero','02'),
			$column = REPLACE($column,'february','02'),
			$column = REPLACE($column,'feb','02'),
			$column = REPLACE($column,'marzo','03'),
			$column = REPLACE($column,'march','03'),
			$column = REPLACE($column,'mar','03'),
			$column = REPLACE($column,'april','04'),
			$column = REPLACE($column,'abril','04'),
			$column = REPLACE($column,'abr','04'),
			$column = REPLACE($column,'apr','04'),
			$column = REPLACE($column,'mayo','05'),
			$column = REPLACE($column,'may','05'),
			$column = REPLACE($column,'june','06'),
			$column = REPLACE($column,'junio','06'),
			$column = REPLACE($column,'jun','06'),
			$column = REPLACE($column,'july','07'),
			$column = REPLACE($column,'julio','07'),
			$column = REPLACE($column,'jul','07'),
			$column = REPLACE($column,'august','08'),
			$column = REPLACE($column,'agosto','08'),
			$column = REPLACE($column,'ago','08'),
			$column = REPLACE($column,'aug','08'),
			$column = REPLACE($column,'september','09'),
			$column = REPLACE($column,'septiembre','09'),
			$column = REPLACE($column,'sep','09'),
			$column = REPLACE($column,'octubre','10'),
			$column = REPLACE($column,'october','10'),
			$column = REPLACE($column,'oct','10'),
			$column = REPLACE($column,'noviembre','11'),
			$column = REPLACE($column,'november','11'),
			$column = REPLACE($column,'nov','11'),
			$column = REPLACE($column,'december','12'),
			$column = REPLACE($column,'diciembre','12'),
			$column = REPLACE($column,'dec','12'),
			$column = REPLACE($column,'dic','12');
		";
		$con->query($sql);
		
		$dformat = strtolower($dformat);
		$dformat = str_replace('y','Y',$dformat);
		$formato = str_split($dformat);
		
		$sql="UPDATE $table_name SET $column = STR_TO_DATE($column, '%$formato[0]-%$formato[1]-%$formato[2]');";
		$con->query($sql);
		
		$sql="UPDATE $table_name SET $column = NULL WHERE $column = '0000-00-00';";
		$con->query($sql);

		return "ok";
	}
	
	
	public function ChangeColumnToDateTime($table_base, $table_dest, $column, $dformat, $delimiter, $timedel, $con){	

		unset($sql,$oldId,$newId);
		$sql = "DROP TABLE IF EXISTS $table_dest;";
		$con->query($sql);
		$sql = "CREATE TABLE $table_dest AS SELECT * FROM $table_base;";
		$con->query($sql);
		$sql = "TRUNCATE $table_dest;";
		$con->query($sql);
		$oldId = $table_base . "_id";
		$newId = $table_dest . "_id";
		$sql = "ALTER TABLE $table_dest CHANGE COLUMN `$oldId` `$newId` double NOT NULL default '0';";
		$con->query($sql);
		switch ($dformat){
			case "YMD": $dformat = "012"; break;
			case "YDM": $dformat = "021"; break;
			case "DMY": $dformat = "210"; break;
			case "DYM": $dformat = "120"; break;
			case "MYD": $dformat = "102"; break;
			case "MDY": $dformat = "201"; break;
		}
		/*$dformat = str_replace("Y","0",$dformat);
		$dformat = str_replace("M","1",$dformat);
		$dformat = str_replace("D","2",$dformat);*/
		$pos = str_split($dformat);		
		$meses = array(99,31,28,31,30,31,30,31,31,30,31,30,31);
		$messp = array("x","enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre");
		$mesen = array("x","january","february","march","april","may","june","july","august","september","october","november","december");
		
		$sql = "SELECT * FROM $table_base WHERE `$column` IS NOT NULL AND `$column` != '' AND `$column` != '0000-00-00 00:00:00';";
		$res = $con->query($sql);

		unset($cadena);
		while($fila = $con->fetch($res)){
			$fectime = explode(' ',$fila[$column]);
			$fecha = explode($delimiter,$fectime[0]);
			$ano = trim($fecha[$pos[0]]);
			$mes = trim($fecha[$pos[1]]);
			$dia = trim($fecha[$pos[2]]);
			$tiempo = explode($timedel,$fectime[1]);
			$hora = trim($tiempo[0]);
			$minuto = trim($tiempo[1]);
			$segundo = trim($tiempo[2]);
			
			if(ereg("^[0-9][0-9]$", $ano)){
				if($ano <= intval(date("y"))){
					$ano = "20".$ano;
				}else {
					$ano = "19".$ano;
				}											
			}
			
			$mes=trim(strtolower($mes));
			for ($x=1;$x<=count($meses);$x++){
				if ($mes == $messp[$x] || $mes == substr($messp[$x],0,3) || $mes == $mesen[$x] || $mes == substr($mesen[$x],0,3)){
					if($x<10){
						$mes="0".$x;
					}else {
						$mes=$x;
					}
				}
			}
			
			unset($cadena);
			$cadena = $ano . "-" . $mes . "-" . $dia . " " . $hora . ":" . $minuto . ":" . $segundo;
			$fallo = false;
			if(!ereg("^([0-9]{4})-((0?[1-9])|(1[0-2]))-((0[1-9])|((1|2)[0-9])|(3[0-1])) (([0-1][0-9])|(2[0-3])):([0-5][0-9]):([0-5][0-9])$", $cadena)){
				$fallo = true;
			}else{
				if(($ano>=0 && $ano<=9999) && ($mes>0 && $mes<=12) && (($dia>0 && $dia<=$meses[intval($mes)]) || ($mes ==2 && $dia==29 && ( ($ano % 400) == 0 || (($ano % 4) == 0 && ($ano % 100) != 0))))){
				}else {
					$fallo = true;
				}
			}
			if ($fallo == true){
				unset($cons);
				for($x=0;$x<=(count($fila)/2)-1;$x++){
					$fila[$x] = str_replace("'","\'",$fila[$x]);
					$fila[$x] = str_replace('"','\"',$fila[$x]);
					$cons .= " '$fila[$x]',";
				}
				$cons = trim(substr($cons,0,strlen($cons)-1));
				$query = "INSERT INTO $table_dest VALUES ($cons);";
				$con->query($query);
			}
		}
		unset($res,$sql,$val,$mat);
		$sql = "SELECT COUNT(*) FROM $table_dest;";
		$res = $con->query($sql);
		$val = $con->fetch($res);
		$mat['count'] = $val[0];
		$mat['answer'] = "ok";		
		return $mat;	
	}
	
	public function TransformToDateTime($table_name, $column, $dformat, $delimiter, $timdel, $con){
		
		unset($sql);
		
		$sql = "UPDATE $table_name SET $column = REPLACE($column,'$delimiter','-')";
		$con->query($sql);
		
		$sql="UPDATE $table_name SET $column = TRIM(LOWER($column));";
		$con->query($sql);
		
		$sql="UPDATE $table_name SET 
			$column = REPLACE($column,'january','01'),
			$column = REPLACE($column,'enero','01'),
			$column = REPLACE($column,'ene','01'),
			$column = REPLACE($column,'jan','01'),
			$column = REPLACE($column,'febrero','02'),
			$column = REPLACE($column,'february','02'),
			$column = REPLACE($column,'feb','02'),
			$column = REPLACE($column,'marzo','03'),
			$column = REPLACE($column,'march','03'),
			$column = REPLACE($column,'mar','03'),
			$column = REPLACE($column,'april','04'),
			$column = REPLACE($column,'abril','04'),
			$column = REPLACE($column,'abr','04'),
			$column = REPLACE($column,'apr','04'),
			$column = REPLACE($column,'mayo','05'),
			$column = REPLACE($column,'may','05'),
			$column = REPLACE($column,'june','06'),
			$column = REPLACE($column,'junio','06'),
			$column = REPLACE($column,'jun','06'),
			$column = REPLACE($column,'july','07'),
			$column = REPLACE($column,'julio','07'),
			$column = REPLACE($column,'jul','07'),
			$column = REPLACE($column,'august','08'),
			$column = REPLACE($column,'agosto','08'),
			$column = REPLACE($column,'ago','08'),
			$column = REPLACE($column,'aug','08'),
			$column = REPLACE($column,'september','09'),
			$column = REPLACE($column,'septiembre','09'),
			$column = REPLACE($column,'sep','09'),
			$column = REPLACE($column,'octubre','10'),
			$column = REPLACE($column,'october','10'),
			$column = REPLACE($column,'oct','10'),
			$column = REPLACE($column,'noviembre','11'),
			$column = REPLACE($column,'november','11'),
			$column = REPLACE($column,'nov','11'),
			$column = REPLACE($column,'december','12'),
			$column = REPLACE($column,'diciembre','12'),
			$column = REPLACE($column,'dec','12'),
			$column = REPLACE($column,'dic','12');
		";
		$con->query($sql);
		
		$dformat = strtolower($dformat);
		$dformat = str_replace('y','Y',$dformat);
		$formato = str_split($dformat);
		
		$sql="UPDATE $table_name SET $column = STR_TO_DATE($column, '%$formato[0]-%$formato[1]-%$formato[2] %H$timdel%i$timdel%s') WHERE $column IS NOT NULL;";
		$con->query($sql);
		
		return "ok";
	}

	public function ChangeColumnToTime($table_base, $table_dest, $column, $timedel, $con){	

		unset($sql,$oldId,$newId);
		$sql = "DROP TABLE IF EXISTS $table_dest;";
		$con->query($sql);
		$sql = "CREATE TABLE $table_dest AS SELECT * FROM $table_base;";
		$con->query($sql);
		$sql = "TRUNCATE $table_dest;";
		$con->query($sql);
		$oldId = $table_base . "_id";
		$newId = $table_dest . "_id";
		$sql = "ALTER TABLE $table_dest CHANGE COLUMN `$oldId` `$newId` double NOT NULL default '0';";
		$con->query($sql);
		$sql = "SELECT * FROM $table_base WHERE `$column` IS NOT NULL AND `$column` != '';";
		$res = $con->query($sql);

		unset($cadena);
		while($fila = $con->fetch($res)){			
			$tiempo = explode($timedel,$fila[$column]);
			$hora = trim($tiempo[0]);
			$minuto = trim($tiempo[1]);
			$segundo = trim($tiempo[2]);
			
			unset($cadena);
			$cadena = $hora . ":" . $minuto . ":" . $segundo;
			$fallo = false;
			if(!ereg("^(([0-1][0-9])|(2[0-3])):([0-5][0-9]):([0-5][0-9])$", $cadena)){
				$fallo = true;
			}
			if ($fallo == true){
				unset($cons);
				for($x=0;$x<=(count($fila)/2)-1;$x++){
					$fila[$x] = str_replace("'","\'",$fila[$x]);
					$fila[$x] = str_replace('"','\"',$fila[$x]);
					$cons .= " '$fila[$x]',";
				}
				$cons = trim(substr($cons,0,strlen($cons)-1));
				$query = "INSERT INTO $table_dest VALUES ($cons);";
				$con->query($query);
			}
		}
		unset($res,$sql,$val,$mat);
		$sql = "SELECT COUNT(*) FROM $table_dest;";
		$res = $con->query($sql);
		$val = $con->fetch($res);
		$mat['count'] = $val[0];
		$mat['answer'] = "ok";		
		return $mat;	
	}
	
	public function TransformToTime($table_name, $column, $timdel, $con){
		
		unset($sql);
		
		$sql="UPDATE $table_name SET $column = STR_TO_DATE($column, '%H$timdel%i$timdel%s');";
		$con->query($sql);

		return "ok";
	}
}
?>