<?php
function matchInit(){
	$xres = new xajaxResponse();
	try {
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$id_usu = $_SESSION["id_usu"];
		$_SESSION["table_name"] = '';
		require_once("../../class/msg/algorithmForm.php");
		$xres->clear('MainDiv','innerHTML');
		$alg_form = new algorithmForm($conten,$mov,'matchsteps');
		$name = "multiselectMatch";
		$dataFields = "['id', 'table_name']";
		$encdec = new EncDec();
		$filter = "SELECT nom_tabla FROM tabxfile t, archivos a WHERE a.id_arch = t.id_arch AND a.id_usu = $id_usu";
		$fromData = $encdec->jMatchComboSelect($filter,'nom_tabla',$con);				
		$toData = "[]";
		$width = 170;
		$height = 160;
		$valueField = 'table_name';
		$displayField = 'table_name';
		$fieldLabel = 'Available Attributes';
		$fromLabel = 'Available Tables';
		$toLabel = 'Selected Tables';
		$desc = "";
		$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);		
		$msg = "<br>Match Duplicates<br>&nbsp; ";
		$xres->create('MainDiv','div','matchsteps');
		$xres->assign('matchsteps','style','width:200px;height:200px;');
		$alg_form->setFormWidthGen(400);
		$xres->assign('matchsteps','innerHTML', $alg_form->getFormStruct("<B></B>",$msg));
		$xres->script("SBItemStat = 0;");
		$func = "xajax_attributeJoin('')";		
		$xres->script($alg_form->getForm($func));
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function attributeJoin($null, $form){	
	$xres = new xajaxResponse();
	try {
		require_once("../../class/msg/algorithmForm.php");
		$xres->script("CleanMatch = 'match2';");
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$form = str_replace("'","\'",$form);	
		$encdec = new EncDec();
		
		$arr = $encdec->JDecode($form);		
		$args = $encdec->JSBDecode($arr['multiselectMatch']);		
		if(count($args) != 2){
			throw new Exception("You have to select 2 data tables to proceeed.");
		}		
		$combo_columns[0] = $encdec->jComboSelect($args[0],$con);
		$fieldLabelOne = $args[0] . " Total Attributes " . $encdec->getNumRows();
		$combo_columns[1] = $encdec->jComboSelect($args[1],$con);
		$fieldLabelTwo = $args[1] . " Total Attributes " . $encdec->getNumRows();
		
		$alg_form = new algorithmForm($conten,$mov,'matchsteps');
		$desc = "<B>Column:</B> list of number fields";

		$name = "multiselect";
		$dataFields = "['id', 'attribute_name']";
		$encdec = new EncDec();
		$filter = "SELECT nom_tabla FROM tabxfile t, archivos a WHERE a.id_arch = t.id_arch AND a.id_usu = $id_usu";
		$toData = "[]";
		$width = 170;
		$height = 160;
		$valueField = 'attribute_name';
		$displayField = 'attribute_name';		
		$fromLabel = 'Available Attributes';
		$toLabel = 'Selected Attributes';
		$desc = "";
		$alg_form->addMultiselect($args[0],$fromLabel,$toLabel,$dataFields,$combo_columns[0],$toData,$width,$height,$valueField,$displayField,$fieldLabelOne,"false",$desc);
		$alg_form->addMultiselect($args[1],$fromLabel,$toLabel,$dataFields,$combo_columns[1],$toData,$width,$height,$valueField,$displayField,$fieldLabelTwo,"false",$desc);
		$alg_form->setFormWidthGen(730);
		$msg = "<br>Attribute Join<br>&nbsp; ";
		$xres->assign('matchsteps','innerHTML', $alg_form->getFormStructTwo("<B></B>",$msg));
		$xres->script("SBItemStat = 0;");		
		$func = "xajax_matchRelations('".$args[0]."','".$args[1]."')";
		$xres->script($alg_form->getForm($func));
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function matchRelations($table_1, $table_2, $form){
	$xres = new xajaxResponse();
	try{		
		$form = str_replace("'","\'",$form);	
		$encdec = new EncDec();
		$arr = $encdec->JDecode($form);
		$args_1 = $encdec->JSBDecode($arr[$table_1]);
		$args_2 = $encdec->JSBDecode($arr[$table_2]);
		if(count($args_1) < count($args_2)){
			throw(new Exception("The number of attributes selected in $table_1 for matching are less than $table_2."));
		}elseif (count($args_1) > count($args_2)){
			throw(new Exception("The number of attributes selected in $table_2 for matching are less than $table_1."));
		}elseif (count($args_1) == 1 && count($args_2) == 1){
			if($args_1[0] == '' && $args_2[0] == ''){
				throw(new Exception("Must exist at least one attribute selected in $table_1 and in $table_2."));
			}elseif($args_1[0] == ''){
				throw(new Exception("Must exist at least one attribute selected in $table_1."));	
			}elseif ($args_2[0] == ''){
				throw(new Exception("Must exist at least one attribute selected in $table_2."));	
			}			
		}
		$html = "<table class='csvFieldResume' border='1'>
		<tr><td colspan='2' align='center'><b>ATTRIBUTE RELATIONS</b></td></tr>
		";
		for($i = 0; $i < count($args_1); $i++){
			$html .= "<tr><td align='center'> ".$args_1[$i]." </td><td align='center'>" .$args_2[$i] ."</td></tr>";
		}
		$html .= "</table>";
		$xres->assign('right_div','innerHTML', $html);		
		$xres->script("matchFiltersEnable = true;");
		session_start();
		$table_dest = "tmp_". $_SESSION['nom_usu'];
		$_SESSION['matchTables'] = $table_1 .",". $table_2 . "," . $table_dest;
		$_SESSION['args_1'] = $args_1;
		$_SESSION['args_2'] = $args_2;
		
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function matchAlgorithms($id){
	$xres = new xajaxResponse();
	try {
		session_start();
		$table_dest = "tmp". $_SESSION['nom_usu'];
		$tables = explode(",",$_SESSION['matchTables']);
		$args_1 = $_SESSION['args_1'];
		$args_2 = $_SESSION['args_2'];
		$con = new MySQLConex();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		require_once("../../class/msg/algorithmForm.php");
		$conten = "400,320";
		$mov = "100,20";
		//$xres->clear('algorithm-dlg','innerHTML');
		$alg_form = new algorithmForm($conten,$mov,'matchsteps');
		$name = "multiselect";
		$dataFields = "['id', 'column_name']";
		$fromData = "[";
		for($i = 0; $i < count($args_1); $i++){
			$fromData .= "['__" . $args_1[$i] ."_". $args_2[$i]  . "__','" . $args_1[$i] ." - ". $args_2[$i] ."'],";
		}
		$fromData = substr($fromData,0, strlen($fromData)-1);
		$fromData .= "]";				
		$toData = "[]";
		$width = 250;
		$height = 180;
		$valueField = 'column_name';
		$displayField = 'column_name';
		$fieldLabel = '';
		$fromLabel = 'Available Columns';
		$toLabel = 'Selected Columns';
		$desc = "";
		$alg_form->addMultiselect($name,$fromLabel,$toLabel,$dataFields,$fromData,$toData,$width,$height,$valueField,$displayField,$fieldLabel,"true",$desc);
		$alg_form->setFormWidthGen(570);
		$msg = "<br>Table Match Procedure<br>&nbsp; ";
		$xres->assign('matchsteps','innerHTML', $alg_form->getFormStruct("<B></B>",$msg));
		$xres->script("SBItemStat = 0;");
		$func = "xajax_ApplyMatchAlgs('$id')";
		$xres->script($alg_form->getForm($func));
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function ApplyMatchAlgs($id, $form){
	$xres = new xajaxResponse();
	try {
		require_once('../../class/msg/AlgDialog.php');
		require_once('../../class/msg/dupgridclass.php');
		$form = str_replace("'","\'",$form);
		$encdec = new EncDec();
		$arr = $encdec->JDecode($form);	
		$fields = explode("%2C",$arr['multiselect']);
		session_start();
		$table_dest = "tmp". $_SESSION['nom_usu'];
		$tables = explode(",",$_SESSION['matchTables']);
		$args_1 = $_SESSION['args_1'];
		$args_2 = $_SESSION['args_2'];
		foreach($fields as $value) {
			$arr2 = explode('-',$value);
			$args_3[count($args_3)] = $arr2[0];
			$args_4[count($args_4)] = $arr2[1];
		}		
		for($i=0; $i < count($args_4);$i++){
			$args_3[$i] = trim(urldecode($args_3[$i]));
			$args_4[$i] = trim(urldecode($args_4[$i]));			
		}		
		$con = new MySQLConex();		
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$xres->script("Ext.MessageBox.wait('Processing Data', 'Please Wait...');");

		switch ($id){
			case 40:
				//match duplicates
				require_once("MatchFilters/MatchDuplicates.php");
				$MD = new MatchDuplicates();
				$answer = $MD->MatchDuplicates($tables[0],$tables[1],$tables[2],$args_1,$args_2,$args_3,$args_4,$con);
				$title = "<b>Match Duplicates</b>";
				$width = "850";
				$msgForm = "Match Duplicates Procedure";
				$msgDescription = "The following rows of <b>".$tables[0] ." and ". $tables[1]."</b> are duplicates<br>&nbsp;";
				break;
			case 41:
				require_once("MatchFilters/MatchSoundex.php");
				$MS = new MatchSoundex();
				$answer = $MS->MatchSoundex($tables[0],$tables[1],$tables[2],$args_1,$args_2,$args_3,$args_4,$con);
				$title = "<b>Match Duplicates</b>";
				$width = "850";
				$msgForm = "Match Duplicates Soundex Procedure";
				$msgDescription = "The following rows of <b>".$tables[0] ." and ". $tables[1]."</b> are possible duplicates<br>&nbsp;";				
				break;
			default:
				break;
		}
		if($answer == "ok"){
			 $xres->script("Ext.MessageBox.hide();");
		}			
				$conten = "950,505";
				$mov = "5,3";
				$xres->clear("algorithm-aux","innerHTML");				
				$CCT = new AlgDialog($conten,$mov,"algorithm-aux");
				$xres->assign('algorithm-aux','innerHTML', $CCT->getFormStruct($title,$width,$msgForm));
				$xres->script($CCT->getDLG());
				$query = "8";
				$grid = new dupgrid($tables[2],'',$query,'table_alg','',$id,$tables[0]."_".$tables[1]);
				$grid->setForm();
				$js = $grid->define_grid($con);		
				$xres->assign('description_alg','innerHTML',$msgDescription);
				$xres->script($js);		
		$con->cerrar();
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function matchHelp(){
	$xres = new xajaxResponse();
	try {
		$h_c_width = "100%";
		$h_c_height = "100%";
		ob_start();
		?>
		<table width="<?php echo $h_c_width; ?>px;" height="<?php echo $h_c_height; ?>px" bgcolor="#E6E6CC">
		<tr>
			<td class="help-heads">
				Description
			</td>
		</tr>
		<tr>
			<td class="help-content">
				This Module, is designed to work with two selection filters: <b>Duplicates Search</b> and <b>Soundex Search</b> which<br>
				take as an aim, the search of duplicated and possible duplicates rows of 2 tables jointly<br><br>
				Often, 2 tables do not have the same quantity of attributes and/or the attributes that relate between them<br>
				are identified by different names, for this reason, it is necessary	to choose what attributes are common<br>
				between these 2 tables.<br><br>
				Once the relations have been specified between the attributes of both tables, it is necessary to specify<br>
				with which of these new relations there is going to be executed one of the filters included in this module.<br><br>
				The result, is a new data table who shows the duplicates or possible duplicates found.
			</td>
		</tr>
		<tr>
			<td class="help-heads">
				Example
			</td>
		</tr>
		<tr>
			<td class="help-content">
				Below, there is showed an example of this module in functioning.<br><br>
				First, select the two data tables.<br><br>
				<img src='../../icons/match1.JPG'><br><br>
				Now, specify the common attributes between the 2 data tables selected.<br>
				All the relations specified here will be showed as a column of the result data table.<br>
				Don't forget to press the Ready button to enable de filters application.<br><br>
				<img src='../../icons/match2.JPG'><br><br>
				In any of the filters, you have to select if they all or some of the made relations<br>
				will be born in mind for the application of the same one.<br><br>
				<img src='../../icons/match3.JPG'>><br><br>
				Using the Duplicates Search filter, this are the result showed.<br><br>
				<img src='../../icons/match4.JPG'><br><br>
				
			</td>
		</tr>
		</table>
		<?php
		$varia = ob_get_clean();
		$xres->assign("MatchHelp","innerHTML",$varia);
	}catch (Exception $e){
		$msg = str_replace("'","\'",$e->getMessage());
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;	
}
?>
