<?php
function Export($table_name,$id){
	$xres = new xajaxResponse();
	try {
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		switch ($id){
			case 1:
				//XLS
				$url = "../../Export/xlsexport.php?table=$table_name";
				$js = "window.open(\"$url\",'exp_window','top=0,left=0,height=1,width=1,scrollbars=YES,resizable=YES,directories=NO,location=NO,menubar=NO,status=NO,titlebar=NO,toolbar=NO');";
				$xres->script($js);
				break;
			case 2:
				//csv				
				require_once("../../class/msg/FormatForm.php");
				$conten = "530,340";
				$mov = "150,15";		
				$form = new FormatForm($conten,$mov,".csv",3);
				$form->setCSVExportTable($table_name);	
				$xres->assign('algorithm-dlg','innerHTML',$form->getFormStruct("CSV Export",""));
				$xres->script($form->getJS());
				$xres->clear('disc_div','innerHTML');
				$xres->assign('disc_div','innerHTML',$form->getForm());
				$xres->create('disc_div','div','csvFormDiv');
				$xres->script($form->setCSVForm('csvFormDiv','csvApply',2));
				break;
			case 3:
				//sql
				require("sqlexport.php");
				$exp = new sqlExport($table_name,$con);
				$file = $exp->export();
				$url = "../../Export/export.php?filename=$file";
				$js = "window.open(\"$url\",'exp_window','top=0,left=0,height=1,width=1,scrollbars=YES,resizable=YES,directories=NO,location=NO,menubar=NO,status=NO,titlebar=NO,toolbar=NO');";
				$xres->script($js);			
				break;
			case 4:
				//arff
				require("arffexport.php");
				$exp = new arffExport($table_name,$con);
				$file = $exp->export();
				$url = "../../Export/export.php?filename=$file";
				$js = "window.open(\"$url\",'exp_window','top=0,left=0,height=1,width=1,scrollbars=YES,resizable=YES,directories=NO,location=NO,menubar=NO,status=NO,titlebar=NO,toolbar=NO');";
				$xres->script($js);
				break;
			case 11:
				//XLS
				require("xlszipexport.php");
				$exp = new xlsExport($table_name,$con);
				$file = $exp->export();
				$base_name = $table_name .".xls";
				$url = "../../Export/export.php?filename=$file";
				$js = "window.open(\"$url\",'exp_window','top=0,left=0,height=1,width=1,scrollbars=YES,resizable=YES,directories=NO,location=NO,menubar=NO,status=NO,titlebar=NO,toolbar=NO');";
				$xres->script($js);
				break;
			case 22:
				//csv.zip				
				require_once("../../class/msg/FormatForm.php");
				$conten = "530,340";
				$mov = "150,15";		
				$form = new FormatForm($conten,$mov,".csv",3);
				$form->setCSVExportTable($table_name);	
				$xres->assign('algorithm-dlg','innerHTML',$form->getFormStruct("CSV Export",""));
				$xres->script($form->getJS());
				$xres->clear('disc_div','innerHTML');
				$xres->assign('disc_div','innerHTML',$form->getForm());
				$xres->create('disc_div','div','csvFormDiv');
				$xres->script($form->setCSVForm('csvFormDiv','csvApply',3));			
				break;
			case 33:
				//sql.zip
				require("sqlexport.php");			
				$exp = new sqlExport($table_name,$con);	
				$file = $exp->export();			
				//$file = $table_name . ".sql";
				//$url = "../../Export/sqlfexport.php?filename=$file";
				$zp = new ZipArchive();
				$filename = "$table_name.zip";
				$base_name = $table_name .".sql";
				$url = "../../Export/export.php?filename=$filename";	
				if (!$zp->open($filename, ZIPARCHIVE::CREATE)) {
					$xres->alert("cannot open <$filename>");
				}
				$zp->addFile("./$file","$file");
				$zp->close();
				unlink($base_name);
				unset($zp);
				$js = "window.open(\"$url\",'exp_window','top=0,left=0,height=1,width=1,scrollbars=YES,resizable=YES,directories=NO,location=NO,menubar=NO,status=NO,titlebar=NO,toolbar=NO');";
				$xres->script($js);			
				break;
			case 44:
				//arff.zip
				require("arffexport.php");
				$exp = new arffExport($table_name,$con);
				$file = $exp->export();
				$zp = new ZipArchive();
				$filename = "$table_name.zip";
				if (!$zp->open($filename, ZIPARCHIVE::CREATE)) {
					$xres->alert("cannot open <$filename>");
				}
				$zp->addFile("./$file","$file");
				$zp->close();
				unset($zp);
				$base_name = $table_name .".arff";
				unlink($base_name);
				$url = "../../Export/export.php?filename=$filename";
				$js = "window.open(\"$url\",'exp_window','top=0,left=0,height=1,width=1,scrollbars=YES,resizable=YES,directories=NO,location=NO,menubar=NO,status=NO,titlebar=NO,toolbar=NO');";
				$xres->script($js);
				break;
			default:
				break;
		}
		$con->cerrar();
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
///function verify CSv export Form
function verifyCSV($args,$table_name,$btnPress){
	$xres = new xajaxResponse();
	if($args['sep'] == $args['num']){		
		$js = "Ext.MessageBox.alert('Alert', 'Field Delimiter and Decimal Symbol must be diferent.');";
		$xres->script($js);
		$xres->script("csvApply.disable();");
	}else{
		if($btnPress == 1){
		}else{
			if(count($args) == 6){
				$cab = 0;
				$sep = $args['sep'];
			}elseif(count($args) == 7 && $args['o_sep'] != ''){
				$cab = 0;
				$sep = $args['o_sep'];
		
			}elseif (count($args) == 7 && $args['cab'] != '') {
				$sep = $args['sep'];
				$cab = $args['cab'];
			}else{
				$sep = $args['o_sep'];
				$cab = $args['cab'];
			}
			if($sep == "t"){
				$sep = "\t";
			}
			$cad = $args['cad'];
			$num = $args['num'];
			$t_fecha = $args['t_fecha'];
			$d_fecha = $args['d_fecha'];
			$d_tiempo = $args['d_tiempo'];
			if($cad == 3){
				$cad = '';
			}elseif($cad == 2){
				$cad = '"';
			}else{
				$cad = "'";
			}				
			//----------------------------			
			$con = new MySQLConex();
			session_start();
			$log = $_SESSION['nom_usu'];
			$cla = $_SESSION['cla_usu'];
			$con->abrir($log,$cla);

			//the file name to export
			$outFile = $table_name . ".csv";
			$file = fopen($outFile,"w+");
			unset($out,$Field,$Type,$fields,$aux);
			$sql = "SHOW COLUMNS FROM $table_name";			
			$res = $con->query($sql);
			$id = $table_name . "_id";
			while($row = $con->fetch($res)){	
				if($row["Field"] != $id){
					$aux .= $row["Field"] . $sep;
					$fields .= "`" . $row["Field"] ."`,";
					$Field[count($Field)] = $row["Field"];
					$Type[count($Type)] = $row["Type"];
				}
			}
			if($cab == 1){
				$out = $aux;
				$out = substr($out,0,strlen($out)-1);
				$out .= "\n";	
			}
			$fields = substr($fields,0,strlen($fields)-1);	
			$sql = "SELECT $fields FROM $table_name";			
			$res = $con->query($sql);
			while($row = $con->fetch($res))
			{
				for($F = 0; $F < count($Field); $F++){
					if($Type[$F] == "varchar(255)"){
						$out .= $cad . $row[$Field[$F]] . $cad . $sep;	
					}
					if($Type[$F] == "double"){
					//$out .= $row[$Field[$F]] . $sep;
						if($num == "."){
							$out .= str_replace(",",".",$row[$Field[$F]]). $sep;
						}else{
							$out .= str_replace(".",",",$row[$Field[$F]]) . $sep;
						}
					}
					if($Type[$F] == "date"){
					//0000-00-00
						if(strlen($row[$Field[$F]])!=0){
							$fecha = explode("-",$row[$Field[$F]]);
							$tipo = str_split($t_fecha);			
							$out .= $cad . $fecha[$tipo[0]] . $d_fecha . $fecha[$tipo[1]]  . $d_fecha . $fecha[$tipo[2]] . $cad . $sep;
						}else{
							$out .= $cad.$cad . $sep;
						}
					}
				}
				$out = substr($out,0,strlen($out)-1);
				$out .= "\n";
				fwrite($file, $out);
				unset($out);
			}
			fclose($file);
			$con->cerrar();
			
			//-------------------------------
			unset($url);						
			$xres->script("Ext.MessageBox.hide();");
			//validate if it is a csv file or a csv.zip file
			if($btnPress == 3){				
				$zp = new ZipArchive();
				$filename = "$table_name.zip";
				$base_name = $table_name .".csv";
				$url = "../../Export/export.php?filename=$filename";	
				if (!$zp->open($filename, ZIPARCHIVE::CREATE)) {
					$xres->alert("cannot open <$filename>");
				}
				$zp->addFile("./$outFile","$outFile");
				$zp->close();
				unlink($base_name);
				unset($zp);
			}else{
				$url = "../../Export/export.php?filename=$outFile";	
			}
			//send the sentence to download de file
			$js = "window.open(\"$url\",'exp_window','top=0,left=0,height=1,width=1,scrollbars=YES,resizable=YES,directories=NO,location=NO,menubar=NO,status=NO,titlebar=NO,toolbar=NO');";
			$xres->script($js);
		}
	}
	return $xres;
}
?>