<?php
class Carga{
	//ban_cab es una bandera que detemrina si la primera fila tiene o no el nombre de las columans
	//1 = SI, 2 = NO
	//delimiter es el delimitador por el cual se identifica el archivo csv
	// tabulador = "\t",  coma = ",",  puntoycoma = ";" espacio = " " o el que se quiera
	//enclosure es el delimitador de cadenas
	//comillas = "", comillas simples '' o ninguna

	private $ruta;
	private $ban_cab;
	private	$delimiter;
	private	$opdel;
	private $id_div;
	private $cab;
	
	public function __construct($ruta, $ban_cab, $delimiter, $opdel, $id_div){
		$this->ruta = $ruta;
		$this->ban_cab = $ban_cab;
		$this->delimiter = $delimiter;
		$this->opdel= $opdel;
		$this->id_div = $id_div;
	}
	//function cargar
	//Permite armar la tabla en tiempo real de acuerdo a los parametros que se le especifiquen
	public function cargar(){
		try{
			unset($this->cab);
			$this->ruta = str_replace(";","/",$this->ruta);
			//echo $this->ruta;
			//echo ereg("(\.)(csv$)",$this->ruta);
			if(ereg("(\.)(csv$)",$this->ruta) != 1){
				throw(new Exception("File $this->ruta not valid."));				
			}else{
				$ape = fopen($this->ruta,"r");
			}			
			if(!$ape){
				throw(new Exception("File $this->ruta not found"));
			}else{
				$i=0;
				if($this->opdel == 1)	$enclosure = "'";
				else $enclosure = '"';
				$numcols = 0;
				$control = $this->ban_cab;
				if($this->delimiter == "t") $this->delimiter = "\t";
				$dataTable = "<table cellspacing='0' id='the-table'>
				";
				$tableH = '';
				$tableD = '';
				while ($readcsv = fgetcsv ($ape,0,$this->delimiter,$enclosure)){
					if($i == 0 && $this->ban_cab == 1){
						$tableH .= "<thead>
						";
					}elseif(($i == 0 && $this->ban_cab == 2) || $this->ban_cab == 3){
						$this->ban_cab = 4;
						$tableD .= "<tbody>
						"; 
					}
					$j = 0;
					if(count($readcsv) > $numcols) $numcols = count($readcsv);
					foreach($readcsv as $col){
						if($i==0 && $this->ban_cab == 1){
							if($j == 0) {					
								$tableH .= "<tr>
								<th width='130'>" . utf8_encode($col) . "</th>
								";
								$j = 1;
								$this->cab[count($this->cab)] = utf8_encode($col);
							}
							else{
								$tableH .= "<th width='130'>" . utf8_encode($col) . "</th>
								";
								$this->cab[count($this->cab)] = utf8_encode($col);
							}
						}else{
							if($j == 0) { 
								$tableD .= "<tr>
								<td>" . utf8_encode($col) . "</td>
								";
								$j = 1;
							}
							else{
								$tableD .= "<td>" . utf8_encode($col) . "</td>
								";
							}
						}
					}
					if($i==0 && $this->ban_cab == 1) {
						$tableH .= "</tr>
						</thead>
						";
						$this->ban_cab = 3;
					}else { $tableD .= "</tr>"; }
					$i++;
					if($i == 25) break;				
				}
				$tableD .= "</tbody>
				";
				
				if($tableH == ''){
					$tableH = "<thead>
					";
					for($x = 0; $x < $numcols; $x++){
						$num = $x+1;
						$tableH .= "<th> field $num </th>
						";
						$this->cab[count($this->cab)] = 'field' . $num;
					}
					$tableH .= '</thead>
					';
				}				
				$dataTable .= $tableH . $tableD . "
				</table>";
				return $dataTable;
			}			
		}catch(Exception $e){
			throw($e);			
		}	
	}//fin funcion cargar
	
	public function get_Cab(){
		return $this->cab;
	}
}//fin clase carga
?>