<?php
class Cargaxls{
	//ban_cab es una bandera que detemrina si la primera fila tiene o no el nombre de las columans
	//1 = SI, 2 = NO
	//delimiter es el delimitador por el cual se identifica el archivo csv
	// tabulador = "\t",  coma = ",",  puntoycoma = ";" espacio = " " o el que se quiera
	//enclosure es el delimitador de cadenas
	//comillas = "", comillas simples '' o ninguna

	private $ruta;
	private $ban_cab;
	private $id_div;
	private $cab;
	
	public function __construct($ruta, $ban_cab, $id_div){
		$this->ruta = $ruta;
		$this->ban_cab = $ban_cab;
		$this->id_div = $id_div;
	}
	//function cargar
	//Permite armar la tabla en tiempo real de acuerdo a los parametros que se le especifiquen
	public function cargar(){
		try{
			
			unset($this->cab);
			$this->ruta = str_replace(";","/",$this->ruta);
			
			$i=0;
			$numcols = 0;
			$control = $this->ban_cab;
			$dataTable = "<table cellspacing='0' id='the-table'>";
			unset($tableH, $tableD);
			////////
			require_once('../../class/format/Excel/reader.php');////
			$data = new Spreadsheet_Excel_Reader();////
			$data->setUTFEncoder('iconv');////
			$data->setOutputEncoding('UTF-8');////
			$data->read($this->ruta);////

			$tableH = "<thead>";
			if ($this->ban_cab == 1){
				$ini = 2;
				for ($j = 1; $j <= $data->sheets[0]['numCols']; $j++){//Columna						
					$celda = $data->sheets[0]['cells'][1][$j];
					$tableH .= "<th>".$celda."</th>";
					$this->cab[count($this->cab)] = $celda;
				}
			}else {
				$ini = 1;
				for ($j = 1; $j <= $data->sheets[0]['numCols']; $j++){//Columna						
					$tableH .= "<th>field".$j."</th>";		
					$this->cab[count($this->cab)] = 'field'.$j;				
				}
			}
			$tableH .= "</thead>";
			
			$tableD = "<tbody>"; 
			
			if ($data->sheets[0]['numRows']<=25){
				$hasta = $data->sheets[0]['numRows'];
			}else{
				$hasta = 25;
			}
			
			for ($i = $ini; $i <= $hasta; $i++){//fila
				$tableD .= "<tr>"; 
				for ($j = 1; $j <= $data->sheets[0]['numCols']; $j++){//Columna
					$tableD .= "<td>"; 
					$tableD .= $data->sheets[0]['cells'][$i][$j];
					$tableD .= "</td>"; 
				}
				$tableD .= "</tr>"; 
			}
			$tableD .= "</tbody>";
			$dataTable .= $tableH . $tableD . "</table>";

			return $dataTable;
			
		}catch(Exception $e){
			throw($e);			
		}
	}//fin funcion cargar
	
	public function get_Cab(){
		return $this->cab;
	}
}//fin clase carga
?>