<?php
class Import{

	private $ruta;
	private $usuarch;
	private	$delimiter;
	private	$opdel;
	private $t_fecha;
	private $d_fecha;
	private $t_datos;
	private $d_tiempo;
	private $mat_datos;
	private $ban_cab;
	
	//private $con;
	
	public function __construct(){
	}
	
	//function cargar
	public function importar($usuarch, $delimiter, $opdel, $ban_cab, $t_fecha, $d_fecha, $d_tiempo, $mat_datos, $con){
		
		$this->usuarch = $usuarch;     		//File Name
		$this->delimiter = $delimiter;  	//Field Delimiter
		$this->ban_cab = $ban_cab;			//If first row is title
		$this->t_fecha = $t_fecha;			//Date format
		$this->d_fecha = $d_fecha;			//Date Delimiter
		$this->d_tiempo = $d_tiempo;		//Time Delimiter
		$this->mat_datos = $mat_datos;		//Field Name and Type
		$this->opdel = $opdel;				//String Delimiter
		try{
			$ruta = str_replace("___",";",$this->usuarch);
			$this->ruta = "..;..;Server_folder;" . 	$ruta;
			
			$user = str_replace("___","_",$this->usuarch);
			$this->usuarch = substr($user, 0, strlen($user)-4);
			$sql = "DROP TABLE IF EXISTS $this->usuarch;";
			$con->query($sql);
			$sql = "CREATE TABLE $this->usuarch ($this->usuarch" . "_id double NOT NULL auto_increment, ";
			
			unset($this->t_datos);
			for ($x = 0; $x < count($this->mat_datos); $x++){
				$sql .= "`".str_replace(" ","_",$this->mat_datos[$x][0]) . "` " . $this->mat_datos[$x][1] . ", ";
				$this->t_datos[$x] = $this->mat_datos[$x][1];
			}
			
			$sql .= "PRIMARY KEY  ($this->usuarch" . "_id)) ENGINE=InnoDB DEFAULT CHARSET=utf8";			
			
			$con->query($sql);

			$this->ruta = str_replace(";","/",$this->ruta);			
			$file = fopen($this->ruta,"r");
			if(!$file) 
			{
				throw(new Exception("File $this->ruta not found."));
			}else{
				$b = 0;
				if($this->opdel == 1)	$enclosure = "'";
				else $enclosure = '"';
				if($this->delimiter == "t") $this->delimiter = "\t";
				$pos = str_split($this->t_fecha);
				$ii = 1;				
				$meses = array(99,31,28,31,30,31,30,31,31,30,31,30,31);
				$messp = array("x","enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre");
				$mesen = array("x","january","february","march","april","may","june","july","august","september","october","november","december");
				$cant = 0;
				
				while ($contape = fgetcsv($file,2000,$this->delimiter,$enclosure)){
					if(count($contape) < count($this->mat_datos)){
						fclose($file);
						$att = count($this->mat_datos);
						$val = count($contape);
						$dif = count($this->mat_datos) - count($contape);
						throw(new Exception("The number of attributes($att) is bigger than the number of values($val). Difference = $dif",467678));
					}
					if(count($contape) > count($this->mat_datos)){
						fclose($file);
						$att = count($this->mat_datos);
						$val = count($contape);
						$dif = count($contape) - count($this->mat_datos);
						throw(new Exception("The number of attributes($att) is smaller than the number of values($val). Difference = $dif",467678));
	
					}
					if ($this->ban_cab == 1 && $ii == 1){
						$ii = 0;
					}else{						
						$cant++;						
						if ($cant==2001){
							$cant = 1;
						}						
						if ($cant == 1){
							$sql = "INSERT INTO $this->usuarch VALUES ";
						}						
						$sql .= "('',";						
						for($i= 0; $i<count($contape); $i++){						
							$contape[$i] = trim($contape[$i]);
							switch ($this->t_datos[$i]) {
								case 'varchar(255)':
									$contape[$i] = str_replace("'","\'",$contape[$i]);
									$contape[$i] = str_replace('"','\"',$contape[$i]);
									if($contape[$i] != '' && $contape[$i] != NULL){
										$sql .= '"' . $contape[$i] . '",';
									}else{
										$sql .= "NULL,";
									}								
									break;
								case 'double':
									unset($cadena);
										$cadena = str_replace(",",".",$contape[$i]);
										if ($cadena == "" || $cadena == "NULL"){
											$sql.= "NULL,";
										}else{
											if(ereg("^-?([0-9]+(\.)?[0-9]*$|(\.)[0-9]+$)", $cadena)!=1){
												$sql2 = "ALTER TABLE $this->usuarch MODIFY ". $this->mat_datos[$i][0] ." varchar(255);";
												$con->query($sql2);
												$b = 1;
												$this->t_datos[$i] = "varchar(255)";
												$i--;
											}else{
												$number = number_format($cadena, 10, '.', '');
												$sql .= $number . ",";
											}
										}
									break;
									
								case 'int(11)':
									
									unset($cadena);
									$cadena = $contape[$i];
									if ($cadena == "" || $cadena == "NULL"){
										$sql.= "NULL,";
									}else{
										if(ereg("^-?([0-9])+$", $cadena)!=1){
											$sql2 = "ALTER TABLE $this->usuarch MODIFY ". $this->mat_datos[$i][0] ." varchar(255);";
											$con->query($sql2);
											$b = 1;
											$this->t_datos[$i] = "varchar(255)";
											$i--;
										}else{
											$sql .= $cadena . ",";
										}
									}
									break;
									
									
								case 'date':
									unset($cadena);
									if(strlen($contape[$i]) != 0){
										$fecha = explode($this->d_fecha,$contape[$i]);
										$ano = $fecha[$pos[0]];
										$mes = $fecha[$pos[1]];
										$dia = $fecha[$pos[2]];
										
										if(ereg("^[0-9][0-9]$", $ano)){
											if($ano <= intval(date("y"))){
												$ano = "20".$ano;
											}else {
												$ano = "19".$ano;
											}
										}
										
										$mes=trim(strtolower($mes));
										for ($x=1;$x<=count($meses);$x++){
											if ($mes == $messp[$x] || $mes == substr($messp[$x],0,3) || $mes == $mesen[$x] || $mes == substr($mesen[$x],0,3)){
												if($x<10){
													$mes="0".$x;
												}else {
													$mes=$x;
												}
											}
										}
										
										$cadena = $ano . "-" . $mes . "-" . $dia;
										if ($cadena != '0000-00-00'){
											$fallo = false;
											if(!ereg("^([0-9]{4})-((0?[0-9])|(1[0-2]))-((0?[0-9])|((1|2)[0-9])|(3[0-1]))$", $cadena)){
												$fallo = true;
											}else{
												if(($ano>=0 && $ano<=9999) && ($mes>0 && $mes<=12) && (($dia>0 && $dia<=$meses[intval($mes)]) || ($mes ==2 && $dia==29 && ( ($ano % 400) == 0 || (($ano % 4) == 0 && ($ano % 100) != 0))))){
													$sql .= "\"".$cadena."\"," ;
												}else {
													$fallo = true;
												}
											}											
											if ($fallo == true){
												throw(new Exception("The column ".$this->mat_datos[$j-1][0]." has values who doesn't match whit the date format defined, please import this column as String an them aply the ChangeColumnType filter to see the errors",777888));
											}
										}
										else {
											$cadena = "NULL";
											$sql .= $cadena."," ;
										}
									}else{
										$cadena = "NULL";
										$sql .= $cadena."," ;
									}
									break;
								case 'datetime':
									unset($cadena);
									if(strlen($contape[$i]) != 0){
										$fectime = explode(" ",$contape[$i]);
										$fecha = explode($this->d_fecha,$fectime[0]);
										$ano = $fecha[$pos[0]];
										$mes = $fecha[$pos[1]];
										$dia = $fecha[$pos[2]];
										$tiempo = explode($this->d_tiempo,$fectime[1]);
										$hora = $tiempo[0];
										$minuto = $tiempo[1];
										$segundo = $tiempo[2];
										
										if(ereg("^[0-9][0-9]$", $ano)){
											if($ano <= intval(date("y"))){
												$ano = "20".$ano;
											}else {
												$ano = "19".$ano;
											}
										}
										
										$mes=trim(strtolower($mes));
										for ($x=1;$x<=count($meses);$x++){
											if ($mes == $messp[$x] || $mes == substr($messp[$x],0,3) || $mes == $mesen[$x] || $mes == substr($mesen[$x],0,3)){
												if($x<10){
													$mes="0".$x;
												}else {
													$mes=$x;
												}
											}
										}
										
										$cadena = $ano . "-" . $mes . "-" . $dia . " " . $hora . ":" . $minuto . ":" . $segundo;
										if ($cadena != '0000-00-00 00:00:00'){
											$fallo = false;
											if(!ereg("^([0-9]{4})-((0?[1-9])|(1[0-2]))-((0[1-9])|((1|2)[0-9])|(3[0-1])) (([0-1][0-9])|(2[0-3])):([0-5][0-9]):([0-5][0-9])$", $cadena)){
												$fallo = true;
											}else{
												if(($ano>=0 && $ano<=9999) && ($mes>0 && $mes<=12) && (($dia>0 && $dia<=$meses[intval($mes)]) || ($mes ==2 && $dia==29 && ( ($ano % 400) == 0 || (($ano % 4) == 0 && ($ano % 100) != 0))))){
													$sql .= "\"".$cadena."\",";
												}else {
													$fallo = true;
												}
											}
											if ($fallo == true){
												throw(new Exception("The column ".$this->mat_datos[$j-1][0]." has values who doesn't match whit the date format defined, please import this column as String an them aply the ChangeColumnType filter to see the errors",777888));
											}
										}
										else {
											$cadena = "NULL";
											$sql .= $cadena."," ;
										}
									}else{
										$cadena = "NULL";
										$sql .= $cadena."," ;
									}
									break;
								case 'time':
									unset($cadena);
									if(strlen($contape[$i]) != 0){
										$tiempo = explode($this->d_tiempo,$contape[$i]);
										$hora = $tiempo[0];
										$minuto = $tiempo[1];
										$segundo = $tiempo[2];
										$cadena = $hora . ":" . $minuto . ":" . $segundo;
										if ($cadena != '00:00:00'){
											$fallo = false;
											if(!ereg("^(([0-1][0-9])|(2[0-3])):([0-5][0-9]):([0-5][0-9])$", $cadena)){
												$fallo = true;
											}else{
												$sql .= "\"".$cadena."\",";
											}
											if ($fallo == true){
												throw(new Exception("The column ".$this->mat_datos[$j-1][0]." has values who doesn't match whit the date format defined, please import this column as String an them aply the ChangeColumnType filter to see the errors",777888));
											}
										}
										else {
											$cadena = "NULL";
											$sql .= $cadena."," ;
										}
									}else{
										$cadena = "NULL";
										$sql .= $cadena."," ;
									}
									break;
								default:
									break;
							}

						}
						$sql = substr($sql,0,strlen($sql)-1);
						$sql .= "),";						
						if($cant == 2000){
							$sql = substr($sql,0,strlen($sql)-1);
							$sql .= ";";
							$con->query($sql);
						}
					}
				}
				
				if($cant < 2000 && $cant>0){
					$sql = substr($sql,0,strlen($sql)-1);
					$sql .= ";";
					$con->query($sql);
				}
			}		
			fclose($file);
			if($b == 1 ){
				return "Cambio_T";
			}
			return "close";
		}catch(Exception $e){
			//467678 number of columns different of number of values
			if ($e->getCode() == 467678) {
				$sql = "DROP TABLE IF EXISTS $this->usuarch;";
				$con->query($sql);
				unlink($this->ruta);
				session_start();
				$id_usu = $_SESSION['id_usu'];
				$sql = "SELECT id_arch FROM archivos WHERE fecha = (SELECT MAX(fecha) FROM archivos WHERE id_usu = '$id_usu');";
				$res = $con->query($sql);
				$row = $con->fetch($res);
				$sql = "DELETE FROM archivos WHERE id_arch = $row[0];";
				$con->query($sql);
				$msg = $e->getMessage();
				throw(new Exception($msg,467678));
				
			}elseif ($e->getCode() == 777888){
				$sql = "DROP TABLE IF EXISTS $this->usuarch;";
				$con->query($sql);
				throw($e);
			}else{
				throw($e);
			}
		}
		//return NULL;
	}   ///////FIN FUNCION IMPORTAR

}
?>