<?php
class ImportSQL{
	private $ruta;
	private $new_table;

	public function __construct(){
	}
	public function import($ruta,$file_name,$con){
		try {
			$this->ruta = str_replace(";","/",$ruta);
			$lines = file($this->ruta);
			if(!$lines)	{
				$errmsg = "cannot open file $this->ruta";
				throw(new Exception($errmsg));
			}			
			$scriptfile = false;
			$linecount =0;
			foreach($lines as $line){
				$linecount++;
				$line = trim($line);
				if($line != ""){
					if((!eregi('^--', $line)) && (!eregi('^#', $line)) && (!eregi('^/\*', $line))){
						$scriptfile .= " ". $line;
					}
				}
			}
			if(!$scriptfile){
				$errmsg = "no text found in $file_name";
				throw(new Exception($errmsg));
			}			
			// Split the jumbo line into smaller lines 
			$queries = explode(';', $scriptfile);
			// Run each line as a query
			foreach($queries as $query){
				if($query != ""){
					$query = trim($query) .";";	
					$queryAux = strtolower($query);
					$queryAux = str_replace('`','',$queryAux);
					if(substr_count($queryAux,"create table") == 0 && substr_count($queryAux,"insert into") == 0){
						$err = substr($query,0,20) ."...";
						$errmsg = "Cannot execute query $err inside $file_name.";
						throw(new Exception($errmsg));
					}
					if(substr_count($queryAux,"create table") != 0){
						if(substr_count($queryAux,"usuario") != 0 || substr_count($queryAux,"tabxfile") != 0 || substr_count($queryAux,"archivos") != 0 ){
							$err = substr($query,0,20) ."...";							
							$errmsg = "Impossible execute the query $err, inside $file_name.";
							throw(new Exception($errmsg));
						}
						//the sql cannot have auto_increment in any column
						if(substr_count($queryAux,"auto_increment") != 0){
							$errmsg = "Cannot exist auto_increment columns, inside $file_name.";
							throw(new Exception($errmsg));
						}
						//the sql cannot have keys // revisar indices y llaves foraneas
						if(substr_count($queryAux,"primary key") != 0){
							$errmsg = "Cannot exist primary key, inside $file_name.";
							throw(new Exception($errmsg));
						}
						//the end of sql sentence must by like ");"
						if(substr($queryAux,strlen($queryAux)-2,2)!= ");"){
							$errmsg = "The end of sql sentence must by like \");\", inside $file_name.";
							throw(new Exception($errmsg));
						}
						//the type supported are varchar(255), double, date, datetime and time
						if(eregi('^(create table).*',$query)){
							$table_name = substr($query,12,strpos($query,'(')-12);
						}
		      				$table_name = str_replace('`','',$table_name);
		      				$table_name = trim($table_name);
						session_start();
					
						$new_table = $_SESSION['nom_usu']."_".$table_name;
						$id_usu = $_SESSION['id_usu'];
						$sql = "SELECT id_arch FROM archivos where fecha = (SELECT MAX(fecha) FROM archivos where id_usu= '$id_usu')";
						$res = $con->query($sql);
						$fila = $con->fetch($res);
						$sql = "INSERT INTO tabxfile values(''," . $fila['id_arch'] .",'$new_table','Filter used in this table: SQL Import(Upload)');";
						$con->query($sql);
					}
					$query = str_replace($table_name,$new_table,$query);
					$con->query($query);
				}
			}
			//alter table
			$Sql = "ALTER TABLE $new_table ADD $new_table"."_id INT UNSIGNED NOT NULL AUTO_INCREMENT FIRST, ADD INDEX ($new_table"."_id);";
			$con->query($Sql);	

			// All is well 			
			$ret['table'] = $new_table;
			$ret['status'] = 'ok';
			return $ret;
		}catch (Exception $e){
			unlink($this->ruta);
			session_start();
			$id_usu = $_SESSION['id_usu'];
			$sql = "SELECT id_arch FROM archivos WHERE fecha = (SELECT MAX(fecha) FROM archivos WHERE id_usu = '$id_usu');";				
			$res = $con->query($sql);
			$row = $con->fetch($res);
			//------ delete the tables alredy created
			$sql = "SELECT nom_tabla FROM tabxfile WHERE id_arch = $row[0];";
			$res = $con->query($sql);;
			while ($rowdel = $con->fetch($res)) {
				$sqldel = "DROP TABLE $rowdel[0];";
				$con->query($sqldel);
			}
			$sql = "DELETE FROM tabxfile WHERE id_arch = $row[0];";
			$con->query($sql);
			$sql = "DELETE FROM archivos WHERE id_arch = $row[0];";
			$con->query($sql);
			//20074 - 1064 -> error in sql syntax
			//if($e->getCode() != 20074 && $e->getCode() != 20075){
			if ($e->getCode() == 20074) {
				throw (new Exception("There is an error in the SQL syntax, inside $file_name"));
			}else{
				throw ($e);			
			}
		}
	}
}
?>