<?php
class Importxls{

	private $ruta;
	private $usuarch;
	private $t_fecha;
	private $d_fecha;
	private $t_datos;
	private $d_tiempo;
	private $mat_datos;
	private $ban_cab;

	public function Importar($usuarch, $ban_cab, $t_fecha, $d_fecha, $d_tiempo, $mat_datos, $con){

		$this->usuarch = $usuarch;     		//File Name
		$this->ban_cab = $ban_cab;			//If first row is title
		$this->t_fecha = $t_fecha;			//Date format
		$this->d_fecha = $d_fecha;			//Date Delimiter
		$this->d_tiempo = $d_tiempo;			//timer Delimiter		
		$this->mat_datos = $mat_datos;		//Field Name and Type

		try{
			$ruta = str_replace("___",";",$this->usuarch);
			$this->ruta = "..;..;Server_folder;" . 	$ruta;

			$user = str_replace("___","_",$this->usuarch);
			$this->usuarch = substr($user, 0, strlen($user)-4);

			$sql = "DROP TABLE IF EXISTS $this->usuarch;";
			$con->query($sql);

			unset($this->t_datos);

			$sql = "CREATE TABLE $this->usuarch ($this->usuarch" . "_id double NOT NULL auto_increment, ";

			for ($x = 0; $x < count($this->mat_datos); $x++){
				$sql .= "`".str_replace(" ","_",$this->mat_datos[$x][0]) . "` " . $this->mat_datos[$x][1] . ", ";
				$this->mat_datos[$x][0] = str_replace(" ","_",$this->mat_datos[$x][0]);
				$this->t_datos[$x+1] = $this->mat_datos[$x][1];
			}

			$sql .= "PRIMARY KEY  ($this->usuarch" . "_id)) ENGINE=InnoDB DEFAULT CHARSET=utf8";			
			$con->query($sql);

			$this->ruta = str_replace(";","/",$this->ruta);

			require_once('../../class/format/Excel/reader.php');
			$data = new Spreadsheet_Excel_Reader();
			$data->setUTFEncoder('iconv');
			$data->setOutputEncoding('UTF-8');
			$data->read($this->ruta);

			$b = 0;
			$pos = str_split($this->t_fecha);
			if ($this->ban_cab == 1){
				$ini = 2;
			}else {
				$ini = 1;
			}

			$meses = array(99,31,28,31,30,31,30,31,31,30,31,30,31);
			$messp = array("x","enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre");
			$mesen = array("x","january","february","march","april","may","june","july","august","september","october","november","december");

			$cant = 0;/////////////////
			unset($sql);

			for ($i = $ini; $i <= $data->sheets[0]['numRows']; $i++){//fila

				$cant++;
				if ($cant==2001){
					$cant = 1;
				}
				if ($cant == 1){
					$sql = "INSERT INTO $this->usuarch VALUES ";
				}

				$sql .= "('',";

				for ($j = 1; $j <= $data->sheets[0]['numCols']; $j++){//Columna

					$celda = trim(utf8_decode($data->sheets[0]['cells'][$i][$j]));

					switch ($this->t_datos[$j]) {
						case 'varchar(255)':
							$celda = str_replace("'","\'",$celda);
							$celda = str_replace('"','\"',$celda);
							if($celda != '' && $celda != NULL){
								$sql .= '"'.$celda.'",';
							}else{
								$sql .= 'NULL,';
							}							
							break;

						case 'date':
							unset($cadena);
							if(strlen($celda) != 0){
								$fecha = explode($this->d_fecha,$celda);
								$ano = $fecha[$pos[0]];
								$mes = $fecha[$pos[1]];
								$dia = $fecha[$pos[2]];

								if(ereg("^[0-9][0-9]$", $ano)){
									if($ano <= intval(date("y"))){
										$ano = "20".$ano;
									}else {
										$ano = "19".$ano;
									}
								}

								$mes=trim(strtolower($mes));
								for ($x=1;$x<=count($meses);$x++){
									if ($mes == $messp[$x] || $mes == substr($messp[$x],0,3) || $mes == $mesen[$x] || $mes == substr($mesen[$x],0,3)){
										if($x<10){
											$mes="0".$x;
										}else {
											$mes=$x;
										}
									}
								}

								$cadena = $ano . "-" . $mes . "-" . $dia;
								if ($cadena != '0000-00-00'){
									$fallo = false;
									if(!ereg("^([0-9]{4})-((0?[0-9])|(1[0-2]))-((0?[0-9])|((1|2)[0-9])|(3[0-1]))$", $cadena)){
										$fallo = true;
									}else{
										if(($ano>=0 && $ano<=9999) && ($mes>0 && $mes<=12) && (($dia>0 && $dia<=$meses[intval($mes)]) || ($mes ==2 && $dia==29 && ( ($ano % 400) == 0 || (($ano % 4) == 0 && ($ano % 100) != 0))))){
											$sql .= "\"".$cadena."\"," ;
										}else {
											$fallo = true;
										}
									}
									if ($fallo == true){
										throw(new Exception("The column ".$this->mat_datos[$j-1][0]." has values who doesn't match whit the date format defined, please import this column as String an them aply the ChangeColumnType filter to see the errors",777888));
									}
								}
								else {
									$cadena = "NULL";
									$sql .= $cadena."," ;
								}
								
							}else{
								$cadena = "NULL";
								$sql .= $cadena."," ;
							}
							break;

						case 'double':
							unset($cadena);
							$cadena = str_replace(",",".",$celda);
							if ($cadena == "" || $cadena == "NULL"){
								$sql.= "NULL,";								
							}else{
								if(ereg("^-?([0-9]+(\.)?[0-9]*$|(\.)[0-9]+$)", $cadena)!=1){
									$sql2 = "ALTER TABLE $this->usuarch MODIFY ". $this->mat_datos[$j-1][0] ." varchar(255);";
									$con->query($sql2);								
									$b = 1;
									$this->t_datos[$j] = "varchar(255)";
									$j--;
								}else{								
									$number = number_format($cadena, 10, '.', '');
									$sql .= $number . ",";									
								}
							}							
							break;
							
						case 'int(11)':
							
							unset($cadena);
							$cadena = $celda;
							if ($cadena == "" || $cadena == "NULL"){
								$sql.= "NULL,";
							}else{
								if(ereg("^-?([0-9])+$", $cadena)!=1){
									$sql2 = "ALTER TABLE $this->usuarch MODIFY ". $this->mat_datos[$j-1][0] ." varchar(255);";
									$con->query($sql2);
									$b = 1;
									$this->t_datos[$j] = "varchar(255)";
									$j--;
								}else{
									$sql .= $cadena . ",";
								}
							}
							break;
							

						case 'datetime':
							unset($cadena);
							if(strlen($celda) != 0){
								$fectime = explode(" ",$celda);										
								$fecha = explode($this->d_fecha,$fectime[0]);
								$ano = $fecha[$pos[0]];
								$mes = $fecha[$pos[1]];
								$dia = $fecha[$pos[2]];
								$tiempo = explode($this->d_tiempo,$fectime[1]);
								$hora = $tiempo[0];
								$minuto = $tiempo[1];
								$segundo = $tiempo[2];								
								if(ereg("^[0-9][0-9]$", $ano)){
									if($ano <= intval(date("y"))){
										$ano = "20".$ano;
									}else {
										$ano = "19".$ano;
									}
								}								
								$mes=trim(strtolower($mes));
								for ($x=1;$x<=count($meses);$x++){
									if ($mes == $messp[$x] || $mes == substr($messp[$x],0,3) || $mes == $mesen[$x] || $mes == substr($mesen[$x],0,3)){
										if($x<10){
											$mes="0".$x;
										}else {
											$mes=$x;
										}
									}
								}

								$cadena = $ano . "-" . $mes . "-" . $dia . " " . $hora . ":" . $minuto . ":" . $segundo;
								if ($cadena != '0000-00-00 00:00:00'){
									$fallo = false;											
									if(!ereg("^([0-9]{4})-((0?[1-9])|(1[0-2]))-((0[1-9])|((1|2)[0-9])|(3[0-1])) (([0-1][0-9])|(2[0-3])):([0-5][0-9]):([0-5][0-9])$", $cadena)){
										$fallo = true;
									}else{
										if(($ano>=0 && $ano<=9999) && ($mes>0 && $mes<=12) && (($dia>0 && $dia<=$meses[intval($mes)]) || ($mes ==2 && $dia==29 && ( ($ano % 400) == 0 || (($ano % 4) == 0 && ($ano % 100) != 0))))){
											$sql .= "\"".$cadena."\",";
										}else {
											$fallo = true;
										}
									}											
									if ($fallo == true){
										throw(new Exception("The column ".$this->mat_datos[$j-1][0]." has values who doesn't match whit the date format defined, please import this column as String an them aply the ChangeColumnType filter to see the errors",777888));
									}
								}
								else {
									$cadena = "NULL";
									$sql .= $cadena."," ;
								}
							}else{
								$cadena = "NULL";
								$sql .= $cadena."," ;
							}
							break;

						case 'time':
							unset($cadena);
							if(strlen($celda) != 0){										
								$tiempo = explode($this->d_tiempo,$celda);
								$hora = $tiempo[0];
								$minuto = $tiempo[1];
								$segundo = $tiempo[2];
								$cadena = $hora . ":" . $minuto . ":" . $segundo;										
								if ($cadena != '00:00:00'){
									$fallo = false;
									if(!ereg("^(([0-1][0-9])|(2[0-3])):([0-5][0-9]):([0-5][0-9])$", $cadena)){
										$fallo = true;
									}else{											
										$sql .= "\"".$cadena."\",";												
									}
									if ($fallo == true){
										throw(new Exception("The column ".$this->mat_datos[$j-1][0]." has values who doesn't match whit the date format defined, please import this column as String an them aply the ChangeColumnType filter to see the errors",777888));
									}
								}
								else {
									$cadena = "NULL";
									$sql .= $cadena."," ;
								}
							}else{
								$cadena = "NULL";
								$sql .= $cadena."," ;
							}
							break;							

						default:
							break;
					}

				}//Fin Columna

				$sql = substr($sql,0,strlen($sql)-1);
				$sql .= "),";

				if($cant == 2000){
					$sql = substr($sql,0,strlen($sql)-1);
					$sql .= ";";
					$con->query($sql);
				}

			}//Fin Fila

			if($cant < 2000){
				$sql = substr($sql,0,strlen($sql)-1);
				$sql .= ";";
				$con->query($sql);
			}

			if($b == 1 ){
				return "Cambio_T";
			}
			return "close";
		}catch(Exception $e){
			
			if ($e->getCode() == 777888){
				$sql = "DROP TABLE IF EXISTS $this->usuarch;";
				$con->query($sql);
				throw($e);
			}else{
				throw($e);
			}
		}
		return NULL;	
	}   ///////FIN FUNCION IMPORTAR
}
?>