<?php
/**
 * 
 * @package algorithmform
 */
class standardgrid{
	
	private $addReplace;
	private $table_name;
	private $editable_attrib;
	private $queryparam;
	private $div;
	private $Form;
	private $id_alg;
	private $con;
	private $final_table;
	private $formGen;
	private $addEmailClean;
	private $base_name;
	
	public function __construct($table_name, $editable_attrib, $queryparam, $div,$Form, $id_alg,$final_table,$base_name = ''){
		$this->addEmailClean = '';
		$this->addReplace = '';
		$this->table_name = $table_name;
		$queryparam = str_replace("'","|||",$queryparam);
		$this->editable_attrib = explode(",",$editable_attrib);
		$this->queryparam = $queryparam;
		$this->div = $div;
		$this->Form = $Form;
		$this->id_alg = $id_alg;
		$this->con = $con;
		$this->final_table = $final_table;
		$this->base_name = $base_name;
	}
	public function define_grid($con,$id_own,$reload = ''){
		try {
			$this->con = $con;
			$query = "SHOW COLUMNS FROM $this->table_name ";
			$res = $this->con->query($query);
			$FieldId = 0;
			$js2 = "var dateItems = new Array(); var dateTimeItems = new Array(); var timeItems = new Array();";
			$withTime = '';
			unset($jsonreader,$columnmodel);
			while($row= $this->con->fetch($res)){
				if($FieldId == 0){
					$id = $row["Field"];
					$FieldId = 1;
				}else{
					$name = str_replace(" ","__", $row["Field"]);
					if($row['Type'] == 'double'){
						$types = 'float';
						$kindofcol = 'NumberField';
						$format = "";
					}elseif($row['Type'] == 'int(11)'){
						if($row['Field'] == $this->editable_attrib[1]){
							$types = 'bool';
							$kindofcol = 'Checkbox';
							$format = "";							
						}else{
							$types = 'int';
							$kindofcol = 'NumberField';
							$format = "";
						}
					}elseif($row['Type'] == 'varchar(255)'){
						$types = 'string';
						$kindofcol = 'TextField';
						$format = "";
					}elseif($row['Type'] == 'date'){
						$types = 'date';
						$kindofcol = 'DateField';
						$format = " ,dateFormat:'Y-m-d'";
						$withTime = "no";
					}elseif ($row['Type'] == 'datetime'){
						$types = 'date';
						$kindofcol = 'DateField';
						$format = " ,dateFormat:'Y-m-d H:i:s'";
						$withTime = "yes";
					}elseif ($row['Type'] == 'time'){
						$types = 'date';
						$kindofcol = 'DateField';
						$format = " ,dateFormat:'H:i:s'";
						$withTime = "onlytime";
					}
					$jsonreader .= "{name: '". $name . "', mapping: '". $row["Field"]."', type: '" .$types . "' $format},";
					$columnmodel .= "{						
							id: '". "i" . $name. "i" ."',
							header: '". $row["Field"] . " (" .$row["Type"] . ")" ."',
							dataIndex: '". $name ."',						
							width: 120,";
					if($kindofcol == 'DateField'){
						if($withTime == "no"){
							$columnmodel.= "renderer: formatDate,";
							$js2 .= "dateItems.push('".$row["Field"]."');";
						}elseif($withTime == "yes"){
							$columnmodel.= "renderer: formatDateTime,";
							$js2 .= "dateTimeItems.push('".$row["Field"]."');";
						}else{
							$columnmodel.= "renderer: formatTime, ";
							$js2 .= "timeItems.push('".$row["Field"]."');";
						}							
					}
					$limitedext = array(".csv",".arff",".xls",".sql");
					if($this->editable_attrib[0] == '*' || in_array($row["Field"],$this->editable_attrib) ){
						$columnmodel .="
							editor: new Ed(new fm.". $kindofcol . "({";
							if($kindofcol == 'DateField'){
								if($withTime == "no"){
									$columnmodel.= "dateFormat: 'Y-m-d', format: 'Y-m-d',";
								}elseif($withTime == "yes"){
									$columnmodel.= "dateFormat: 'Y-m-d H:i:s', format: 'Y-m-d H:i:s',";
								}else{
									$columnmodel.= "dateFormat: 'H:i:s', format: 'H:i:s',";
								}
							}
							if($kindofcol == 'NumberField'){
								if($row['Type'] == 'double'){
									$columnmodel.= "decimalPrecision: 20, ";	
								}else{
									$columnmodel.= "allowDecimals:false,maxValue:2147483647,minValue: -2147483648,";
								}
							}
							if($kindofcol == 'Checkbox'){
								$columnmodel .= "checked:true}))},";
							}else{
								$columnmodel.="
								allowBlank: true	}))
							},";
							}
					}else{
						$columnmodel .= "},";
					}				
				}
			}
			$jsonreader = substr($jsonreader,0,strlen($jsonreader)-1);
			$columnmodel = substr($columnmodel,0,strlen($columnmodel)-1);
			
			$js = "
				function formatBoolean(value){
      		  		return value ? 'Accept' : 'Refuse';  
    			}
				function formatDate(value){
					return value ? value.dateFormat('Y-m-d') : '';
	   			}
				function formatDateTime(value){
					return value ? value.dateFormat('Y-m-d H:i:s') : '';
	   			}
				function formatTime(value){
					return value ? value.dateFormat('H:i:s') : '';
	   			}	
				var ps1 = 50;
				ds1 = new Ext.data.Store({			
					proxy: new Ext.data.ScriptTagProxy({
						url: '../../class/gui/GridPhp/datafile.php'
					}),
					reader: new Ext.data.JsonReader({			
						root: 'results',
						totalProperty: 'total',
						id: '$id'
					}, 
					[ ". $jsonreader ." ])
				});
				ds1.baseParams = {'table_name': '$this->table_name', 'query':'$this->queryparam'};
				fm = Ext.form, Ed = Ext.grid.GridEditor;
				cm1 = new Ext.grid.ColumnModel([$columnmodel]);
				grid_alg = new Ext.grid.EditorGrid('$this->div', {
					ds: ds1,
					cm: cm1,
					selModel: new Ext.grid.RowSelectionModel(),	
					loadMask: {msg: 'Retreiving Data, Please Wait...'},			
					listeners:{
						'afteredit': function(oe){
							for(var g = 0; g<dateItems.length; g++){							
								if(oe.field == dateItems[g]){
									oe.value = formatDate(oe.value);
								}
							}
							for(var g = 0; g<dateTimeItems.length; g++){							
								if(oe.field == dateTimeItems[g]){
									oe.value = formatDateTime(oe.value);
								}
							}
							for(var g = 0; g<timeItems.length; g++){							
								if(oe.field == timeItems[g]){
									oe.value = formatTime(oe.value);
								}
							}
							xajax_Grid_Update(ds1.data.items[oe.row].id, oe.field, oe.value , '$this->table_name');";
							if($this->id_alg != 11 && $this->id_alg != 28){
								$js.="xajax_Grid_Update(ds1.data.items[oe.row].id, oe.field, oe.value , '$this->final_table');";
							}
							$js.="
						}
					}
				});
				grid_alg.render();
				//----------------- context menu inside de grid
				var ctxMenu = new Ext.menu.Menu({
					items: [";
						switch ($this->id_alg){
							case 27:
								break;
							default:						
								$js .="{							
									id:'remove',
									//handler:removeNode,
									cls:'x-btn-text-icon remove',
									text: 'Remove',
									icon : '../../icons/cross.gif'
								}";
							break;
						}
						switch ($this->id_alg){
							case 8:
							case 9:
							case 20:
							case 21:
							case 22:
								$js .= ",
								{						
									id:'discard',
									//handler:removeNode,
									cls:'x-btn-text-icon remove',
									text: 'Discard',
									icon : '../../icons/tick.gif'
								}";								
								break;
							default:
								break;
						}
						$js .="
					]
				});	";
				switch ($this->id_alg){
					case 27:
						break;
					default:	
				$js.="
					ctxMenu.items.get('remove').on('click', function(e){
					var selectionModel = grid_alg.getSelectionModel();
					var rows = selectionModel.getSelections();
					var nb = rows.length;
					for(var i=0;i<nb;i++){
						";
						if($id_own == "true"){
							$js.= "						
							xajax_Grid_DeleteIDOWN(rows[i].id, '$this->table_name','$this->final_table');
							";
						}else{
							$js.= "xajax_Grid_Delete(rows[i].id, '$this->table_name');";
							if($this->id_alg != 28){
								$js .="xajax_Grid_Delete(rows[i].id, '$this->final_table');";
							}
						}
						
					$js.="
					}
					ctxMenu.hide();
					ds1.reload();
				});";
					break;
				}
				switch ($this->id_alg){					
					case 8:
					case 9:
					case 20:
					case 21:
					case 22:
						$js .= "
							ctxMenu.items.get('discard').on('click', function(e){
								var selectionModel = grid_alg.getSelectionModel();
								var rows = selectionModel.getSelections();
								var nb = rows.length;
								var arrOfId = new Array();
								for(var i=0;i<nb;i++){
									arrOfId.push(rows[i].id);
									ds1.remove(rows[i]);									
								}
								ctxMenu.hide();								
								xajax_Grid_Delete_B(arrOfId, '$this->table_name');
								//ds1.reload();
						});";						
						break;
					default:
						break;
				}
				$js.="
				grid_alg.on('cellcontextmenu',function(grid, rowIndex, cellIndex, event){
					ctxMenu.showAt(event.getXY());
					event.preventDefault(); // To not display the browser context menu
				});
				//-----------------------			
				//-----------------------
				gridFoot = grid_alg.getView().getFooterPanel(true);	
				paging = new Ext.PagingToolbar(gridFoot, ds1, {
					pageSize: ps1,
					displayInfo: true,
					displayMsg: 'Displaying results {0} - {1} of {2}',
					emptyMsg: 'No results to display'
				});	
				//-------- combo box to set a limit of rows show for the grid			
				PerPageData = [
					['10', 	'10'],
					['25', 	'25'],
					['50', 	'50'],
					['100', '100']
				];
				var ppstore = new Ext.data.SimpleStore({
					fields: ['num', 'txt'],
					data : PerPageData
				});		
				var perPage = new Ext.form.ComboBox({
					store: ppstore,
					displayField:'txt',
					typeAhead: true,
					mode: 'local',
					triggerAction: 'all',
					selectOnFocus:true,
					resizable:false,
					listWidth: 60,
					width: 60,
					value: '50'
				});
		
				function setPerPage()
				{
					paging.pageSize = parseInt(perPage.getValue());	
					paging.cursor = 0;
					ds1.load({params:{start: paging.cursor, limit: paging.pageSize}});
				}
				perPage.on('select', setPerPage);
			
				paging.addSeparator();
				paging.addText('Per Page');		
				paging.addField(perPage);			
				//-----------	
					var gridHead = grid_alg.getView().getHeaderPanel();
					gridHead.show();
					var tb = new Ext.Toolbar(gridHead);
					";
				switch ($this->id_alg){
					case 4:
					case 8:
					case 15:
					case 16:
						$js.="					
						var delete_all = tb.add({
							text: 'Delete All',
							id: 'delete_all',
							tooltip: 'Delete all rows.',
							icon: '../../icons/cross.gif',
							cls: 'x-btn-text-icon btn-search-icon',
							handler: delete_all
						});
						function delete_all(btn){
							ds1.removeAll();
							grid_alg.destroy(true);
							dialog_cct.hide();
							dialog_cct.destroy();
							xajax_Grid_DeleteGroup('$this->id_alg', '$this->table_name','$this->final_table');";
						switch ($this->id_alg){
							case 4:
								$js.= "xajax_GenInvalidCCT('$reload','$this->id_alg', '$this->final_table','$this->base_name', '$this->Form');";
								break;
							case 8:
							case 15:
							case 16:
								$js.="xajax_Exec_Algorithm('1','$this->id_alg','$this->final_table','$this->final_table','','');";
								break;
						}
						$js.= "
						}";
						break;						
				}
				$js.="
				$this->addReplace
				$this->addEmailClean
				//------- to add a export menu.
				Ext.get(Ext.get(tb.addSpacer().getEl()).dom.parentNode).setStyle('width', '100%');
				tb.add({
					cls: 'x-btn-text-icon bmenu', // icon and text class
					icon: '../../icons/disk.gif',
					text:'Export',
					menu:{items: [
					{	text: '<b>XLS</b>',
					 	icon: '../../icons/excel.gif',
						menu:{items:[
					 		{	text: '<b>As .xls</b>',
								icon: '../../icons/excel.gif',
								handler: function(){
					 				xajax_Export('$this->table_name',1);
					 			}
							},
							{	text: '<b>As .xls.zip</b>',
								icon: '../../icons/zip.gif',
								handler: function(){
					 				xajax_Export('$this->table_name',11);
					 			}
							}							
					 	]}
					},
					{	text: '<b>CSV</b>',
						icon: '../../icons/csv.gif',
						menu:{items:[
					 		{	text: '<b>As .csv</b>',
								icon: '../../icons/csv.gif',
								handler: function(){
					 				xajax_Export('$this->table_name',2);
					 			}
							},
							{	text: '<b>As .csv.zip</b>',
								icon: '../../icons/zip.gif',
								handler: function(){
					 				xajax_Export('$this->table_name',22);
					 			}
							}
					 	]}
					},
					{	text: '<b>SQL</b>',
						icon: '../../icons/sql.gif',
						menu:{items:[
					 		{	text: '<b>As .sql</b>',
								icon: '../../icons/sql.gif',
								handler: function(){
					 				xajax_Export('$this->table_name',3);
					 			}
							},
							{	text: '<b>As .sql.zip</b>',
								icon: '../../icons/zip.gif',
								handler: function(){
					 				xajax_Export('$this->table_name',33);
					 			}
							}							
					 	]}
					},
					{	text: '<b>ARFF</b>',
						icon: '../../icons/arff.gif',
						menu:{items:[
					 		{	text: '<b>As .arff</b>',
								icon: '../../icons/arff.gif',
								handler: function(){
					 				xajax_Export('$this->table_name',4);
					 			}
							},
							{	text: '<b>As .arff.zip</b>',
								icon: '../../icons/zip.gif',
								handler: function(){
					 				xajax_Export('$this->table_name',44);
					 			}
							}							
					 	]}
					 }
				]}
				});				
				ds1.load({params:{start:0, limit:ps1}});
				//---------------------- form
				$this->formGen";				
				$javascript = $js2 . $js;				
			return $javascript;
		}catch (Exception $e){
			throw($e);
		}
	}
	public function getForm(){
		return $this->formGen;
	}
	public function setForm($reload = ''){
		try{
			$this->formGen = "
				form_alg = new Ext.form.Form({
					labelWidth: 100
				});
			";
			switch ($this->id_alg){
				case 4:
					$this->formGen .= "
					form_alg.addButton({
						text: 'Analize',						
						handler: function(){
							grid_alg.destroy(true);
							dialog_cct.hide();
							dialog_cct.destroy();							
							xajax_GenInvalidCCT('$reload','$this->id_alg', '$this->final_table','$this->base_name', '$this->Form');
						}
					});
					";
					break;
				case 11:
					$this->formGen .= "
					form_alg.addButton({
						text: 'Replace Characters',
						handler: function(){
							grid_alg.destroy(true);
							dialog_cct.hide();
							dialog_cct.destroy();						
							xajax_GenNPC('$this->id_alg', '$this->table_name','$this->final_table','$this->Form');
						}
					});
					";				
					break;			
			}
			
			$this->formGen .= "
				form_alg.addButton({
						text: 'Save Table',						
						handler: function(){														
							xajax_Dup_tmp_tab('$this->table_name','$this->final_table');
						}
					});
				form_alg.addButton({
					text: 'Close',
					handler: function(){
						grid_alg.destroy(true);
						dialog_cct.hide();
						dialog_cct.destroy();
						if(grid_is_load == 1){
							grid.getDataSource().reload();
						}
					}
				});
				form_alg.render('formulario');
			";
		}catch (Exception $e){
			throw ($e);
		}
	}
	public function addReplace(){
		try {
			$this->addReplace = "
				tb.addSeparator();		
				tb.addDom({				
					tag: 'div',				
					html: '&nbsp;&nbsp;&nbsp;Change all by: '
				});
				var txt_replace = tb.addDom({
					tag: 'input',
					id: 'text_replace',
					type: 'text',
					size: 20,
					value: '',
					style: 'background: #F0F0F9;'
				});
				tb.add({
					text: 'Apply',				
					tooltip: 'Replace editable cells by some value.',
					icon: '../../icons/tick.gif',
					cls: 'x-btn-text-icon btn-search-icon',
					handler: replace_with
				});
	
				function replace_with(btn){				
					var value = Ext.get('text_replace').getValue();

					xajax_Grid_ReplaceCol('".$this->editable_attrib[0]."','$this->table_name', value);";
			
				//if id_alg = 11 (NPCS) then the replace_with function ignore all the newchar typed
				//in the grid and sets all values to the txt_replace.value
				//if id_alg = 4 (CCT) then the replace_with function replace all the editable values
				//in the especified column, not at all
				switch ($this->id_alg){
					case 4:
						$this->addReplace .="
						grid_alg.getDataSource().reload();
						xajax_CCTmptorigin('$this->id_alg','$this->table_name','$this->final_table',value,'".$this->editable_attrib[0]."','$this->Form');";
						break;
					case 11:
						$this->addReplace .="
						grid_alg.destroy(true);
						dialog_cct.hide();
						dialog_cct.destroy();
						xajax_GenNPC('$this->id_alg', '$this->table_name','$this->final_table','$this->Form');";
						break;
				}
				$this->addReplace.= "
				}
			";
		}catch (Exception $e){
			throw ($e);
		}
	}
	//only for email cleaner
	public function UseCorrections(){
		try {
			$this->addEmailClean ="
				tb.addSeparator();		
				tb.add({
					text: 'Use All Corrections',				
					tooltip: 'Use all the suggested email corrections .',
					icon: '../../icons/tick.gif',
					cls: 'x-btn-text-icon btn-search-icon',
					handler: useCorrections
				});
				tb.addSeparator();
				tb.add({
					text: 'Use Selected Corrections',				
					tooltip: 'Use the suggested email corrections selected.',
					icon: '../../icons/tick.gif',
					cls: 'x-btn-text-icon btn-search-icon',
					handler: useSomeCorrections
				});
				function useCorrections(btn){
					xajax_Email_Update('', '', '', '$this->final_table','$this->table_name','yes');					
					grid_alg.destroy(true);
					dialog_cct.hide();
					dialog_cct.destroy();
					grid.getDataSource().reload();
				}
				function useSomeCorrections(){
					xajax_Email_Update('', '', '', '$this->final_table','$this->table_name','no');					
					grid_alg.destroy(true);
					dialog_cct.hide();
					dialog_cct.destroy();
					grid.getDataSource().reload();
				}
			";
		}catch (Exception $e){
			throw ($e);
		}
	}
}
?>