<?php
function open($Status,$fileName,$id){
	$xres = new xajaxResponse();
	try {
		session_start();
		require_once("../../class/msg/algorithmForm.php");
		$_SESSION["table_name"] = '';
		if($Status == 0){
			$conten = "360,180";
			$mov = "220,120";
			$msg = "Select a file to upload<br>&nbsp;";
		}elseif($Status == 1){
			$conten = "320,160";
			$mov = "220,120";
			$msg = "The file cannot be uploaded<br>&nbsp;";
		}	elseif($Status == 2){
			$conten = "380,190";
			$mov = "230,135";
			$msg = "The file already exists, please select another file<br>&nbsp;";
		}elseif($Status == 3){
			$conten = "350,160";
			$mov = "220,130";
			$msg = "Invalid File Extension, please select another file<br>&nbsp;";
		}elseif ($Status == 4){
			$conten = "340,160";
			$mov = "220,130";
			$msg = "Invalid File Size, please select another file<br>&nbsp;";
		}elseif ($Status == 5){
			$conten = "340,160";
			$mov = "220,120";
			$msg = "Invalid File, please select another file<br>&nbsp;";
		}elseif ($Status == 6){
			$conten = "400,190";
			$mov = "220,120";
			$msg = "Invalid File, the file name already exists with another extension<br>&nbsp;";
		}elseif ($Status == 7){
			$conten = "430,200";
			$mov = "220,120";
			$msg = "Invalid File, the ZIP file contains more than one file inside, please verify that there is one file inside<br>&nbsp;";			
		}elseif ($Status == 8){
			$conten = "400,190";
			$mov = "220,120";
			$msg = "Invalid File, the file inside the ZIP file doesn't fulfill with the supported extension format<br>&nbsp;";
		}elseif ($Status == 1000){
			$conten = "400,190";
			$mov = "220,120";
			$msg = "It is a valid file, but it has been associated to an incorrect extension, please select a file with the CSV extension<br>&nbsp;";		
		}elseif ($Status == 1001){
			$conten = "400,190";
			$mov = "220,120";
			$msg = "It is a valid file, but it has been associated to an incorrect extension, please select a file with the XLS extension<br>&nbsp;";				
		}elseif ($Status == 1002){
			$conten = "400,190";
			$mov = "220,120";
			$msg = "It is a valid file, but it has been associated to an incorrect extension, please select a file with the ARFF extension<br>&nbsp;";
		}elseif ($Status == 1003){
			$conten = "400,190";
			$mov = "220,120";
			$msg = "It is a valid file, but it has been associated to an incorrect extension, please select a file with the SQL extension<br>&nbsp;";		
		}elseif ($Status == 1004){
			$conten = "400,190";
			$mov = "220,120";
			$msg = "It is a valid file, but it has been associated to an incorrect extension, please select a file with the ZIP extension<br>&nbsp;";		
		}
		if($id == 1000){
			$typeOf = "CSV";
			$ex = "
			Select a valid file with the Examinar button and upload it.<br>
			It is necessary to specify the format in which is the file: <br>
			- Fields Delimiter<br>
			- Text Qualifier<br>
			- First Row Contains Column Names (yes or not)<br>
			- Date Format (YMD - YDM - DMY - DYM - MYD - MDY)<br>
			- Date Delimiter (/  -)<br>
			- Time Delimiter ( : )<br>
			- Data Types (String - Number - Date - DateTime - Time)<br>
			";
		}elseif ($id == 1001){
			$typeOf = "XLS";
			$ex = "
			Select a valid file with the Examinar button and upload it.<br>
			It is necessary to specify the format in which is the file: <br>
			- First Row Contains Column Names (yes or not)<br>
			- Date Format (YMD - YDM - DMY - DYM - MYD - MDY)<br>
			- Date Delimiter (/  -)<br>
			- Time Delimiter ( : )<br>
			- Data Types (String - Number - Date - DateTime - Time)<br>
			";
		}elseif ($id == 1002){
			$typeOf = "ARFF";
			$ex = "
			Select a valid file with the Examinar button and upload it.<br>
			It is not necessary to specify the format in which is the file but it should have a specific format as the following one: <br><br>
			@RELATION iris<br><br>			
			@ATTRIBUTE sepallength  NUMERIC<br>
			@ATTRIBUTE sepalwidth   NUMERIC<br>
			@ATTRIBUTE petallength  NUMERIC<br>
			@ATTRIBUTE petalwidth   NUMERIC<br>
			@ATTRIBUTE class  {Iris-setosa, Iris-versicolor, Iris-virginica}<br><br>			
			@DATA<br>
			5.1, 3.5, 1.4, 0.2, Iris-setosa<br>
			4.9, 3.0, 1.4, 0.2, Iris-setosa<br>
			4.7, 3.2, 1.3, 0.2, Iris-versicolor<br>
			4.6, 3.1, 1.5, 0.2, Iris-setosa<br>
			5.0, 3.6, 1.4, 0.2, Iris-virginica
			";
		}elseif ($id == 1003){
			$typeOf = "SQL";
			$ex = "
			Select a valid file with the Examinar button and upload it.<br>
			It is not necessary to specify the format in which is the file but only it should have INSERT INTO and CREATE TABLE sentences inside.<br><br>
			CREATE TABLE table1 (one varchar(255), two double NOT NULL);<br>
			INSERT INTO table1 VALUES ('a',1);<br>
			INSERT INTO table1 VALUES ('b',2);<br>
			INSERT INTO table1 VALUES ('c',3);<br>
			";
		}elseif ($id == 1004){
			$typeOf = "ZIP";
			$ex = "
			Select a valid file with the Examinar button and upload it.<br><br>
			It is not necessary to specify the format in which is the file.<br><br>
			Inside the ZIP file must be one file with any supported extension format by EXDACLET<br>
			";
		}
		$upload_form = new algorithmForm($conten,$mov,'algorithm-dlg');
		$xres->assign('algorithm-dlg','innerHTML', $upload_form->getFormStruct("Upload & Import $typeOf File",$msg));
		$xres->script($upload_form->getJS());	
		$xres->script($upload_form->getUploadForm("File",$id));
		$desc = "Allow the user, to upload a file (.$typeOf) to the server and import it to be handle.";		
		$xres->assign('help_div','innerHTML',$upload_form->getHtmlHelp($desc,$ex));
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}		
	return $xres;
}

function cargar($file_name, $inv){
	$xres = new xajaxResponse();	
	try {
		$ext = strrchr($file_name,'.');
		$limitedext = array(".csv",".arff",".xls",".sql",".zip");
		if (!in_array(strtolower($ext),$limitedext)) {
			$js = "Ext.MessageBox.alert('Alert', 'Failure');";
			$xres->script($js);		
		}else{
			require("../../class/msg/FormatForm.php");
			if($ext == ".csv"){
				$conten = "800,570";
				$mov = "50,15";
				$form = new FormatForm($conten,$mov,$ext,1);
				$xres->assign('algorithm-dlg','innerHTML',$form->getFormStruct("Import",""));
				$xres->script($form->getJS());
				$xres->clear('disc_div','innerHTML');
				$xres->assign('disc_div','innerHTML',$form->getForm());
				
				$desc = "This window shows a preview of the data inside the file and allows to define the data structure<br><br>";
				$ex = "
				In the following example, the data structure definition should be like this:<br><br>
				Field Delimiter -> comma<br>
				First Row Contains Column Names -> Enabled<br>
				Text Qualifier -> \"<br>
				Date Format, Date Delimiter, Time Delimiter -> not keep in mind<br>
				Data Type: -> Everything Text<br><br>
				
				Book, Author, Editorial<br>
				\"Robots e Imperio\", \"Isaac Asimov\", \"Plaza y Janés\" <br>
				\"Invernáculo\", \"Brian W. Aldiss\", \"Minotauro\" <br>
				\"Absolute OpenBSD 2d Edition\", \"Michael W. Lucas\", \"No Starch Press\"  <br>
				\"Mercaderes del Espacio\", \"Frederik Pohl, C. M. Kornbluth\",\"Minotauro\"  <br>
				";
				$param_desc = "
				- <b>Field Delimiter:</b> Allows to establish the type of delimiter of fields, it can be comma, semicolon, space, tab or another special delimiter that it is in the file.<br>
				- <b>First Row Contains Column Names:</b>Enabled if the first line contains the names of all and each one of the fields inside the CSV file, disabled otherwise.<br>
				- <b>Text Qualifier:</b> Allows to establish the form in which the text strings are defined. it can be empty, the double quotation mark or the simple quotation mark<br>
				- <b>Date Format:</b> Allows to establish the format in which are the date fields. YMD - YDM - DMY - DYM - MYD - MDY <br>(Y = YEAR, M = MONTH, D = DAY).<br>
				- <b>Date Delimiter:</b> Allows to establish the date fields delimiter (commonly - or /).<br>
				- <b>Time Delimiter:</b> Allows to establish the time or dateTime fields delimiter (commonly :).<br>
				- <b>Data Type:</b> Allows to define each data type to which associates a certain attribute or field they can be String, Number, Date, dateTime or Time<br>
				";
				$form->setParam_desc($param_desc);
				$xres->assign('format_help','innerHTML',$form->getHtmlHelpF($desc,$ex));
				if($inv == 1){
					$js = "Ext.MessageBox.alert('Incorret Field Selection Types', 'Please define a type for all fields.');";					
				}elseif ($inv == 2){
					$js = "Ext.MessageBox.alert('Incorret Column Number', 'The data has more values than atributes.');";
				}
				$xres->script($js);	
				$xres->script("xajax_resumen('');");
			}elseif ($ext == '.xls'){
				$conten = "800,560";
				$mov = "50,15";
				$form = new FormatForm($conten,$mov,$ext,2);
				$xres->assign('algorithm-dlg','innerHTML',$form->getFormStruct("Import",""));
				$xres->script($form->getJS());
				$xres->clear('disc_div','innerHTML');
				$xres->assign('disc_div','innerHTML',$form->getForm());
				$desc = "This window shows a preview of the data inside the file and allows to define the data structure<br><br>";
				$ex = "It is only necessary to define the date formats and if the first row contains the column names<br><br>
				<img width='913' height='196' src='../../icons/excelsample.JPG'>";
				$param_desc = "
				- <b>First Row Contains Column Names:</b>Enabled if the first line contains the names of all and each one of the fields inside the CSV file, disabled otherwise.<br>
				- <b>Date Format:</b> Allows to establish the format in which are the date fields. YMD - YDM - DMY - DYM - MYD - MDY <br>(Y = YEAR, M = MONTH, D = DAY).<br>
				- <b>Date Delimiter:</b> Allows to establish the date fields delimiter (commonly - or /).<br>
				- <b>Time Delimiter:</b> Allows to establish the time or dateTime fields delimiter (commonly :).<br>
				- <b>Data Types:</b> Allows to define each data type to which associates a certain attribute or field they can be String, Number, Date, dateTime or Time<br>
				";
				$form->setParam_desc($param_desc);
				$xres->assign('format_help','innerHTML',$form->getHtmlHelpF($desc,$ex));
				$inv = str_replace("'","\'",$inv);
				if($inv != 0 && $inv != 1){
					$js = "Ext.MessageBox.alert('Incorrect Date Definition','$inv');";				
					$xres->script($js);	
				}				
				$xres->script("xajax_XLSresumen('');");
			}elseif ($ext == '.sql'){
				$xres->script("Ext.MessageBox.wait('Uploading File', 'Please wait');");
				$con = new MySQLConex();
				session_start();
				$log = $_SESSION['nom_usu'];
				$cla = $_SESSION['cla_usu'];
				$con->abrir($log,$cla);
				$id_usu = $_SESSION['id_usu'];
				$nom_usu = $_SESSION['nom_usu'];
				$sql = "SELECT arch_usu FROM archivos where fecha = (SELECT MAX(fecha) FROM archivos where id_usu= '$id_usu')";
				$res = $con->query($sql);
				$fila = $con->fetch($res);
				$ruta = "..;..;Server_folder;".$nom_usu. ";".$fila['arch_usu'];
				//----------------------------
				require_once('../../class/base/importsql.php');
				$impsql = new ImportSQL();
				$retObj = $impsql->import($ruta,$fila['arch_usu'],$con);
				$table = $retObj['table'];
				if($retObj['status'] == 'ok'){
					$xres->script("Ext.MessageBox.hide();");
				}				
				$xres->script("Ext.MessageBox.hide();");
				$con->cerrar();
				$xres->script("xajax_grid('".$table ."');");
				$xres->script("xajax_tree();");
			}elseif ($ext == '.arff'){
				$xres->script("Ext.MessageBox.wait('Uploading File', 'Please wait');");
				$con = new MySQLConex();
				session_start();
				$log = $_SESSION['nom_usu'];
				$cla = $_SESSION['cla_usu'];
				$con->abrir($log,$cla);
				$id_usu = $_SESSION['id_usu'];
				$nom_usu = $_SESSION['nom_usu'];
				$sql = "SELECT arch_usu FROM archivos where fecha = (SELECT MAX(fecha) FROM archivos where id_usu= '$id_usu')";
				$res = $con->query($sql);
				$fila = $con->fetch($res);
				$ruta = "..;..;Server_folder;".$nom_usu. ";".$fila['arch_usu'];
				//----------------------------	
				require_once('../../class/base/importarff.php');
				$imparff = new importarff();
				$retObj = $imparff->importar($ruta,$nom_usu,$con);
				$table = $retObj['table'];
				if($retObj['status'] == 'ok'){
					$xres->script("Ext.MessageBox.hide();");
				}
				$con->cerrar();
				$xres->script("xajax_grid('".$table ."');");
				$xres->script("xajax_tree();");
			}
		}
	}catch (Exception $e){
		//error 1050 sql
		if($ext == '.arff' || $ext == '.sql'){
			$xres->script("Ext.MessageBox.hide();");
		}
		$msg = $e->getMessage();//. "inside cargar function (cargar.php)";
		$msg = str_replace("'","\'",$msg);		
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
		
	return $xres;
}
function XLSresumen($args){
	$xres = new xajaxResponse();	
	try{		
		if($args == NULL){
			$ban_cab = 2;			
			$id_div = "tableresume";			
		}else{
			if($args['cab'] == NULL) $ban_cab = 2;
			else  $ban_cab = 1;
		}
		//---------------------------
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$id_usu = $_SESSION['id_usu'];
		$nom_usu = $_SESSION['nom_usu'];
		$sql = "SELECT arch_usu FROM archivos where fecha = (SELECT MAX(fecha) FROM archivos where id_usu= '$id_usu')";
		$res = $con->query($sql);
		$fila = $con->fetch($res);
		$ruta = "..;..;Server_folder;".$nom_usu. ";".$fila['arch_usu'];
		$con->cerrar();
		
		
		//------------
		$load = new Cargaxls($ruta,$ban_cab,$id_div);		
		$var = $load->cargar();
		$js = "
			var grid2 = new Ext.grid.TableGrid('the-table',{
				loadMask: {msg: 'Reading Data From File, Please Wait...'}
			});
			var layoutres = Ext.BorderLayout.create({
				center: {
					margins:{left:3,top:3,right:3,bottom:3},
					panels: [new Ext.GridPanel(grid2)]
				}
			}, 'tabladedatos');
        	grid2.render();
			";	
		$xres->assign('tabladedatos','innerHTML',$var);
		$xres->script($js);
		
		$cabe = $load->get_cab();
		$head='';
		foreach($cabe as $c){
			$head .= $c . '|';
		}
		$user = $nom_usu. "___".$fila['arch_usu'];	
		if($args == NULL){
			unset($especifications);			
			$especifications .= 't_fecha==>' . '012' . '&&&';
			$especifications .= 'd_fecha==>/&&&';
			$especifications .= 'd_tiempo==>:&&&';
			$especifications .= 'cabecera==>' . $head. "&&&";
			$especifications .= 'usuarch==>' . $user;
		}else{
			unset($especifications);
			foreach ($args as $a => $b){
				$especifications .= $a . "==>" . $b . "&&&";
			}
			$especifications .= 'cabecera==>' . $head. "&&&";
			$especifications .= 'usuarch==>' . $user;
		}		
		$xres->script("xajax_cargarTD('$especifications','xls');");
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function resumen($args){
	$xres = new xajaxResponse();
	try{
		$xres->assign("TypeText","innerHTML",'');
		//$xres->assign("TypeNumber","innerHTML",'');
		//$xres->assign("TypeDate","innerHTML",'');
		if($args == NULL){
			$delimiter = ',';
			$ban_cab = 2;
			$opdel = 2;
			$id_div = "tableresume";			
		}else{
			if($args['sep'] == '-')	$delimiter = $args['o_sep'];
			else	$delimiter = $args['sep'];
			if($delimiter == NULL) $delimiter = ",";
			if($args['cab'] == NULL) $ban_cab = 2;
			else  $ban_cab = 1;
			$opdel = $args['cad'];
			$id_div = "tableresume";
			if($args['num'] == $delimiter){
				throw(new Exception("A"));
			}else{
			$xres->script("document.getElementById('import').disabled = '';");
			}
			$num = $args['num'];
		}
		
		//---------------------------
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$id_usu = $_SESSION['id_usu'];
		$nom_usu = $_SESSION['nom_usu'];
		$sql = "SELECT arch_usu FROM archivos where fecha = (SELECT MAX(fecha) FROM archivos where id_usu= '$id_usu')";
		$res = $con->query($sql);
		$fila = $con->fetch($res);
		$ruta = "..;..;Server_folder;".$nom_usu. ";".$fila['arch_usu'];
		$con->cerrar();
		//----------------------------	
		//with javascript code generation
/*		$load = new Carga($ruta, $ban_cab, $delimiter, $opdel, $id_div);
		$var = $load->cargar();		
		$xres->script($var);
	*/	
		
		//with html code genration
		$load = new Carga($ruta, $ban_cab, $delimiter, $opdel, $id_div);
		$var = $load->cargar();
		//$t = '<div id="tableresume"  style="width:400px;height:250px;"><div id="tabladedatos"></div></div>';
		//$xres->assign('resumen','innerHTML',$t);
		 $js = "
			var grid2 = new Ext.grid.TableGrid('the-table',{
				loadMask: {msg: 'Reading Data From File, Please Wait...'}
			});
			var layoutres = Ext.BorderLayout.create({
				center: {
					margins:{left:3,top:3,right:3,bottom:3},
					panels: [new Ext.GridPanel(grid2)]
				}
			}, 'tabladedatos');
        	grid2.render();
			";	
		$xres->assign('tabladedatos','innerHTML',$var);
		$xres->script($js);
		
		$cabe = $load->get_cab();
		$head='';
		foreach($cabe as $c){
			$head .= $c . '|';
		}
		$user = $nom_usu. "___".$fila['arch_usu'];
		if($args == NULL){
			unset($especifications);			
			$especifications = 'sep==>' . $delimiter . '&&&';
			$especifications .= 'cad==>' . $opdel . '&&&';
			$especifications .= 'num==>.&&&';
			$especifications .= 't_fecha==>' . '012' . '&&&';
			$especifications .= 'd_fecha==>/&&&';
			$especifications .= 'd_tiempo==>:&&&';
			$especifications .= 'cabecera==>' . $head. "&&&";
			$especifications .= 'usuarch==>' . $user;
		}else{
			unset($especifications);
			foreach ($args as $a => $b){
				$especifications .= $a . "==>" . $b . "&&&";
			}
			$especifications .= 'cabecera==>' . $head. "&&&";
			$especifications .= 'usuarch==>' . $user;
		}		
		$xres->script("xajax_cargarTD('$especifications','csv');");
	}catch(Exception $e){
		if($e->getMessage() == 'A'){
			$js = "
				Ext.MessageBox.alert('Alert', 'Field Delimiter and Decimal Symbol must be diferent.');
			";
			$xres->script($js);
			$xres->script("document.getElementById('import').disabled = 'true';");
		}else{
			$xres->alert($e->getMessage());
			//$xres->script("window.parent.hidePopWin(); window.parent.displaySelectBoxes();");
		}
	}
	return $xres;
}

function cargarTD($arg,$typeoffile){
	$xres = new xajaxResponse();
	try {
		$keyvalue = explode("&&&", $arg);
		foreach($keyvalue as $kv){
			$k_v = explode('==>',$kv);
			$args[$k_v[0]] = $k_v[1];
		}
		
		if($args['cab'] == NULL){ 
			$ban_cab = 2;
		}else{
			$ban_cab = 1;
		}
		
		if($args['sep'] == '-')	$delimiter = $args['o_sep'];
		else	$delimiter = $args['sep'];
		if($delimiter == NULL) $delimiter = ",";
		$opdel = $args['cad'];
		$num = $args['num'];	
		$t_fecha = $args['t_fecha'];
		$d_fecha = $args['d_fecha'];
		$d_tiempo = $args['d_tiempo'];
		$usuarch = $args['usuarch'];	
		ob_start();
		?>
		<fieldset>
			<legend>Data Types</legend>
		<form id="uno">
			<table border="0" align="center">
				<tr>
					<td>
						<select name="tipoVar" id="tipoVar" class="x-combo-list-inner"  onChange="retorno('matriz'); xajax_updateBoxes(xajax.$('matriz').value, this.value);">
							<option value="varchar(255)">String</option>
							<option value="double">Number</option>
							<option value="int(11)">Integer</option>
							<option value="date">Date</option>
							<option value="datetime">DateTime</option>
							<option value="time">Time</option>
						</select>
					</td>
				</tr>
				<tr>
					<td>
						<select multiple name="fromBox[]" id="fromBox">
						</select>
						<select multiple name="toBox[]" id="toBox">
						</select>
					</td>
				</tr>
				<tr>
					<td>
						<?php
						if($typeoffile =='csv') {
							$params = "'$usuarch','$delimiter','$opdel','$num','$ban_cab','$t_fecha','$d_fecha','$d_tiempo','$typeoffile'";						
							?><input type="button" value="Import " id="import" name="import" onClick="layoutIsOpen = false; dialog.destroy(); Ext.MessageBox.wait('Importing File', 'Please Wait'); xajax_importar(ret(),<?php echo $params; ?>);"><?php
						}elseif ($typeoffile =='xls'){
							?><input type="button" value="Import " id="import" name="import" onClick="layoutIsOpen = false; dialog.destroy(); Ext.MessageBox.wait('Importing File', 'Please Wait'); xajax_importar(ret(),<?php echo "'$usuarch','','','','$ban_cab','$t_fecha','$d_fecha','$d_tiempo','$typeoffile'"; ?>);"><?php
						}
						?>
						
						<input type="button" value="Cancel " id="cancel" name="cancel" onClick="dialog.hide(); dialog.destroy(); xajax_delete_file('<?php echo $usuarch;?>');">
					</td>
				</tr>
			</table>
			<input type="hidden" id="val" name="val" value="varchar">
			<input type="hidden" id="matriz" name="matriz">
			</form>
			</fieldset>
	<?php
		$xres->assign('fieldselect','innerHTML',ob_get_clean());
		$xres->script("xajax_initBox('".$args['cabecera']."');");
		$xres->script("createMovableOptions('fromBox','toBox',300,180,'Available Columns','Selected Columns');");
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function initBox($cabecera){
	$xres = new xajaxResponse();
	try {
		//Inicializaci�n de matriz	
		$sel = new Select();
		$i = 0;
		$cabecera = explode("|",$cabecera);
		$val = count($cabecera)-1;
		$xres->script("init_BoxSel(".$val.");");
		for($i = 0; $i < count($cabecera) - 1; $i++){
			$sel->agregarOpcion($i, $cabecera[$i]);
			$xres->script("upload_BoxSel(".$i.",'". $cabecera[$i]."');");
		}
		$xres->script($sel->getJavascript('fromBox'));
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function updateBoxes($mat, $val){
	$xres = new xajaxResponse();
	try {
		$sel = new Select();
		$sel1 = new select();
		$mat = explode('||',$mat);
		$i=0;
		for($i = 0; $i < count($mat); $i++){
			$m = explode('|',$mat[$i]);
			if($m[1] == '0'){
				$sel->agregarOpcion($i,$m[0]);
			}elseif($m[1] == $val){
				$sel1->agregarOpcion($i,$m[0]);
			}
		}	
		$xres->script($sel1->getJavascript('toBox'));
		$xres->script($sel->getJavascript('fromBox'));
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}	
	return $xres;
}

function importar($mat_datos, $usuarch, $delimiter, $opdel, $num, $ban_cab, $t_fecha, $d_fecha, $d_tiempo, $impType){
	$xres = new xajaxResponse();
	try{		
		$js = "
		if(grid_is_load){
			grid.destroy(true);
			grid_is_load = false;
			generalTabs.hideTab('Statistics');
		}
		";
		$xres->script($js);
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		if($impType == "csv"){
			$usedFilter = 'CSV Import(Upload)';
			require_once('../../class/base/import.php');
			$importar = new import();			
			$T_E = $importar->importar($usuarch, $delimiter, $opdel, $ban_cab, $t_fecha, $d_fecha, $d_tiempo, $mat_datos, $con);
		}elseif ($impType == "xls"){
			$usedFilter = 'XLS Import(Upload)';
			require_once("../../class/base/importxls.php");	
			$importar = new Importxls();
			$T_E = $importar->Importar($usuarch,$ban_cab,$t_fecha,$d_fecha,$d_tiempo,$mat_datos,$con);
			
		}
		$js = "Ext.MessageBox.hide();";
		$xres->script($js);
		if($T_E == "Cambio_T"){
			$js = "Ext.MessageBox.alert('Alert', 'The data types was changed during import procedure<br>is necesary to check');";
			$xres->script($js);
		}
		unset($Fields,$Table_name);
		foreach($mat_datos as $mat){
			$Fields .= $mat[0] . "|";
		}
		$usuarch1 = str_replace("___","_",$usuarch);		
		$Table_name = substr($usuarch1, 0, strlen($usuarch1)-4);		
		$id_usu = $_SESSION['id_usu'];
		$sql = "SELECT id_arch FROM archivos where fecha = (SELECT MAX(fecha) FROM archivos where id_usu= '$id_usu')";
		$res = $con->query($sql);
		$fila = $con->fetch($res);
	
		$sql = "INSERT INTO tabxfile values(''," . $fila['id_arch'] .",'$Table_name','$usedFilter');";
		$con->query($sql);
		//retorna el id de la tupla que estoy insertando
		//$tabxfile_id = $con->insertId();
		
		$con->cerrar();

		$Fields = substr($Fields, 0, strlen($Fields)-1);
		$xres->script("xajax_grid('".$Table_name ."');");
		$xres->script("xajax_tree();");		
	}catch(Exception $e){	
		$file_name = explode("___",$usuarch);
		if($e->getCode() == 467678){
			$msg = $e->getMessage();
			$js = "
			Ext.MessageBox.hide();
			Ext.MessageBox.alert('Error', '$msg');";
			$xres->script($js);
		}else{
			if(substr_count($e->getMessage(),1136)!=0){				
				$xres->script("xajax_cargar('$file_name[1]',1)");
			}else{
				if($e->getCode() == 777888){
					$msg = $e->getMessage();
					$msg = str_replace("'","\'",$msg);
					$xres->script("xajax_cargar('$file_name[1]','$msg')");
				}else{
					$xres->script("xajax_cargar('$file_name[1]','1')");
				}
			}
		}	
	}
	return $xres;
}

function getAllTypes($mat_datos){
	$xres = new xajaxResponse();
	$typeText = '';
	$typeNumber = '';
	$typeDate = '';
	$type = "Struct{<br>";
	foreach($mat_datos as $mat){
		$type .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$mat[0] as $mat[1];<br>";
	}
	$type .="}";
	$xres->assign("TypeText","innerHTML",$type);
	return $xres;
}
function delete_file($usuarch){
	$xres = new xajaxResponse();
	try {
		$ruta = "..;..;Server_folder;" . str_replace("___",";",$usuarch);	
		$arch = explode("___",$usuarch);	
		$ruta = str_replace(";","/",$ruta);
		unlink($ruta);
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		$con->abrir($log,$cla);
		$id_usu = $_SESSION['id_usu'];
		$sql = "DELETE FROM archivos where arch_usu  = '".$arch[count($arch)-1]."' AND id_usu = $id_usu";
		$con->query($sql);	
		$con->cerrar();
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
?>