<?php
// 	XAJAX
	require_once("../../xajax_0.5/xajax_core/xajax.inc.php");
	include('../../class/bd/MySQLConex.php');
	require_once("../../class/gui/select.php");	
	require_once('../../class/base/EncDec.php');
	$xajax = new xajax();

	$xajax->registerFunction("login",'../../security/security.php');
	$xajax->registerFunction("logueo",'../../security/security.php');
	
 	//VENTANAS DE APLICACION
	$xajax->registerFunction('app');
	$xajax->registerFunction('usersInit');
	$xajax->registerFunction('createAccount');
	$xajax->registerFunction('initAddUser');
	$xajax->registerFunction('initModUser');
	$xajax->registerFunction('modifyAccount');	
	
	$xajax->registerFunction('usertree','../../class/gui/TreePhp/usertree.php');
	$xajax->registerFunction('get_table_name','../../class/gui/TreePhp/usertree.php');
	$xajax->registerFunction('Del_F_T','../../class/gui/TreePhp/usertree.php');
	$xajax->registerFunction('usermodtree','../../class/gui/TreePhp/usertree.php');
	
	$xajax->processRequest();
	//$xajax->debugOn();
?>
<html>
<head>
<META NAME="TITLE" CONTENT="EXDACLET">
<link rel="stylesheet" type="text/css" href="../../class/css/general.css">
<?php $xajax->printJavascript('../../xajax_0.5/'); ?>

<title>E X D A C L E T</title>



<!-- this are the extjs scripts for de grid, tabs, tree, -->
<link rel="stylesheet" type="text/css" href="../../class/css/init_app.css">
<script type="text/javascript" src="../../ext-1.1.1/adapter/ext/ext-base.js"></script>
<script type="text/javascript" src="../../ext-1.1.1/ext-all.js"></script>		
<link rel="stylesheet" type="text/css" href="../../ext-1.1.1/resources/css/ext-all.css">
<link rel="stylesheet" type="text/css" href="../../class/css/accordion.css">
<link rel="stylesheet" type="text/css" href="../../class/css/Multiselect.css">
<link rel="stylesheet" type="text/css" href="../../ext-1.1.1/resources/css/xtheme-aero.css" title="aero">
<link rel="stylesheet" type="text/css" href="../../ext-1.1.1/resources/css/xtheme-gray.css" title="gray">
<link rel="stylesheet" type="text/css" href="../../ext-1.1.1/resources/css/xtheme-vista.css" title="vista">
<link rel="stylesheet" type="text/css" href="../../ext-1.1.1/resources/css/xtheme-galdaka.css" title="galdaka">

<link href="../../class/css/selectBox.css" rel="stylesheet"></link>
<script src="../../class/util/selectBox.js"></script>
<script src="../../class/util/Multiselect.js"></script>
<script src="../../class/util/general.js" type="text/javascript"></script>

<!-- useful for accordion -->
<script type="text/javascript" src="../../class/util/Ext.ux.InfoPanel.js"></script>
<script type="text/javascript" src="../../class/util/Ext.ux.Accordion.js"></script>
<script type="text/javascript" src="../../class/util/styleswitch.js"></script>

<script src="../../class/util/mainCode.js"></script>
</head>
<body id="general_win" style="height:100%;" onLoad="xajax_login('2');" onBeforeUnload= "send_new();" onUnload= "send_new();">
</body>
</html>

<?php
function usersInit(){
$xres = new xajaxResponse();
try {
	
	ob_start();
	?>
	<table width="600px" height="500px" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td height="100%" background="../../Help_Images/background.gif">
			<!--<input type="button" value="press me" onclick="Ext.MessageBox.alert('Status', 'sdakdsaghfkfhgfkj');">-->
			</td>		
		</tr>
		<tr>		
			<td width="80%" valign="top">
				<table width="100%" border="0" height="100%" cellpadding="0" cellspacing="0">				
					<tr>
						<td valign="top" height="500px">
							<div id="container">
								<div id="tabs">
									<!--THIS DIV CONTAINS LIST WITH USERS, FILES AND DATA TABLES-->
									<div id="MainDiv1" style="width:'600px'; height:'450px';  overflow:auto">
										<div id="TreeDiv" style="vertical-align:top;"></div>
									</div>
									<!--THIS DIV CONTAINS FORMS WITH ADD USER OPTIONS-->
									<div id="MainDiv2" style="width:'600px';  height:'450px'; overflow:auto"></div>
									<!--THIS DIV CONTAINS FORMS WITH MODIFY USER OPTIONS-->
									<div id="MainDiv3" style="width:'600px';  height:'450px'; overflow:auto"">										
											<div id="modTree" style="vertical-align:top;" class="x-layout-inactive-content"></div>
											<div id="modUser" style="vertical-align:top;" class="x-layout-inactive-content"></div>										
									</div>
									<div id="MainDiv4"></div>
								</div>
							</div>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
	<div id="algorithm-dlg" style="visibility:hidden;"></div>
	<div id="algorithm-aux" style="visibility:hidden;"></div>
	<?php
		$xres->remove('Content');
		$xres->create('general_win','div','Content');
		$xres->assign('Content','innerHTML', ob_get_clean());
		$xres->script("init_UserContainer();");
		$xres->script("xajax_usertree();");
		$xres->script("xajax_initAddUser();");
		$xres->script("xajax_initModUser('');");
	}catch (Exception $e){
		$msg = $e->getMessage(). "inside workspace function (workspace.php)";
		$js = "Ext.MessageBox.alert('Status', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function app(){
	$xres = new xajaxResponse();
	try {
		$xres->clear('general_win','innerHTML');
		ob_start();
		?>	
		<div id="loading-mask">&nbsp;</div>
		<div id="loading">
			<div class="loading-indicator"><img src="../../icons/loading.gif" style="width:16px;height:16px;" align="absmiddle">&#160;Loading...</div>
		</div>
		<div id="Content"></div>
		<?php	
		$xres->assign('general_win','innerHTML', ob_get_clean());	
		$xres->script("init_app(); xajax_usersInit();");
	}catch (Exception $e){
		$msg = $e->getMessage(). "inside app function (workspace.php)";
		$js = "Ext.MessageBox.alert('Status', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function descargar(){
	$xres = new xajaxResponse();
	try {
		session_start();
		$txt = $_SESSION['id_usu'];
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];
		if($txt != ""){
			$txt = "tiene algo";
			$con = new MySQLConex();
			$con->abrir($log,$cla);
			$sql = "UPDATE usuario SET online = 'n' WHERE id_usu = ".$_SESSION['id_usu'].";";
			$con->query($sql);
			$sql = "SHOW FULL PROCESSLIST";
			$res = $con->query($sql);
			while ($row = $con->fetch($res)){
				$process_id = $row['id'];
				if($row['user'] == $log){
					$sql1 = "KILL $process_id";
					$con->query($sql1);
				}
			}
			$con->cerrar();
		}
		session_unset();
	}catch (Exception $e){
		$msg = $e->getMessage(). "inside descargar function (workspace.php)";
		$js = "Ext.MessageBox.alert('Status', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function initAddUser(){
	$xres = new xajaxResponse();
	try {
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];		
		$con->abrir($log,$cla);
		$sql = "SELECT login FROM usuario;";
		$res = $con->query($sql);
		unset($invalidLogin);
		while($row = $con->fetch($res)){
			$invalidLogin .= $row['login'] . "|s|s|s";
		}
		require_once('../../class/msg/userform.php');
		$uf = new userForm($invalidLogin);
		$xres->remove('addUserCont');
		$xres->create('MainDiv2','div','addUserCont');
		$msg = "Add a new User Account to EXDACLET.";
		$xres->assign('addUserCont','innerHTML', $uf->getFormStruct("<B>Add User</B>",$msg));
		$xres->script($uf->addUserForm());			
		$con->cerrar();
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function createAccount($form){
	$xres = new xajaxResponse();
	try {
		$encdec = new EncDec();
		$arr = $encdec->JDecode($form);		
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];		
		$con->abrir($log,$cla);
		$fname = urldecode($arr['fname']);
		$lname = urldecode($arr['lname']);
		$login = urldecode($arr['login']);
		$pass =  urldecode($arr['pass1']);
		$sql = "SELECT COUNT(*) FROM usuario WHERE login = '$login';";
		$res = $con->query($sql);
		$fila = $con->fetch($res);
		if($fila[0] != 0){
			throw new Exception("User Already Exist.");
		}
		$sql = "INSERT INTO usuario VALUES('','$fname','$lname','$login',MD5('$pass'),'$login','n');";
		$con->query($sql);
		$sql = "GRANT ALL PRIVILEGES ON exdaclet.* TO '$login'@'localhost' IDENTIFIED BY '$pass';";
		$con->query($sql);
		$con->cerrar();
		$url = "../../Server_folder/". $login;
		mkdir($url);
		$msg = "User Account <b>$login</b> Added Correctly.";
		$js = "
		Ext.MessageBox.alert('Status', '$msg');
		addForm.reset();
		";
		$xres->script($js);		
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

function initModUser($nodeId){
	$xres = new xajaxResponse();
	try {		
		if ($nodeId != '') {
			$nodeId = explode("___",$nodeId);
			$con = new MySQLConex();
			session_start();
			$log = $_SESSION['nom_usu'];
			$cla = $_SESSION['cla_usu'];
			$con->abrir($log,$cla);
			$sql = "SELECT firstname, lastname, login, online FROM usuario WHERE id_usu = '$nodeId[0]';";
			$res = $con->query($sql);
			$row = $con->fetch($res);			
			$fname = $row['firstname'];
			$lname = $row['lastname'];
			$login = $row['login'];
			$logged = $row['online'];
			if ($logged == "n") {
				$logged = "No";
			}else {
				$logged = "Yes";
			}
			require_once('../../class/msg/userform.php');
			$uf = new userForm('','div2','err2');
			$msg = "Modify an User Account in EXDACLET.";
			$xres->assign('modUser','innerHTML', $uf->getFormStruct("<B>Modify User</B>",$msg));
			$xres->script($uf->modUserForm($fname,$lname,$login,$logged));
			$con->cerrar();
		}else {
			$xres->script("xajax_usermodtree();");
			$xres->assign("modUser","innerHTML","");
		}
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}
function modifyAccount($form){
	$xres = new xajaxResponse();
	try {
		$encdec = new EncDec();
		$arr = $encdec->JDecode($form);		
		$con = new MySQLConex();
		session_start();
		$log = $_SESSION['nom_usu'];
		$cla = $_SESSION['cla_usu'];		
		$con->abrir($log,$cla);
		$fname = urldecode($arr['fname']);
		$lname = urldecode($arr['lname']);
		$login = urldecode($arr['login']);
		$pass =  urldecode($arr['pass1']);
		$logged = urldecode($arr['logged']);		
		if ($logged == "No") {
			$logged = "n";
		}else {
			$logged = "y";
		}
		$sql = "UPDATE usuario SET firstname = '$fname', lastname = '$lname', pass = MD5('$pass'), online = '$logged' WHERE login = '$login';";
		$con->query($sql);
		$con->cerrar();
		$msg = "User Account <b>$login</b> Modified Correctly.";
		$js = "
		Ext.MessageBox.alert('Status', '$msg');
		//addForm.reset();
		";
		$xres->script($js);		
	}catch (Exception $e){
		$msg = $e->getMessage();
		$js = "Ext.MessageBox.alert('Error', '$msg');";
		$xres->script($js);
	}
	return $xres;
}

?>